//============================================================================
//	axpGP02w.pas
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.00 1999/02/13
//
//============================================================================

unit AxpGp02w;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

const
	//-------------------------------------
	// װ
	//-------------------------------------
	GP02_SUCCESS							=0;
	GP02_ERR_SYSTEM						=1;
  GP02_ERR_NO_DEVICE				=2;
  GP02_ERR_IN_USE						=3;
  GP02_ERR_INVALID_SOCKET		=4;
  GP02_ERR_RESOURCE					=5;
	GP02_ERR_INVALID_ARGUMENT	=6;
	GP02_ERR_NOTINIT					=7;
	GP02_ERR_MODE							=8;
	GP02_ERR_TIMEOUT					=9;
	GP02_ERR_NOLSN						=10;
	GP02_ERR_BUSY							=11;
	GP02_ERR_ETC							=12;
	GP02_ERR_WRAPDLL					=$ffff;	// ׯ߰֐װ
	//-------------------------------------
	// ײү(GPIB)w
	//-------------------------------------
	LA_0=$20;		// OLA
  TA_0=$40;		// OTA
	UNL	=$3f;		// UNListen
	UNT	=$5F;		// UNTalk
	GTL	=$01;		// Go To Local
	SDC	=$04;		// Select Device Clear
	GET	=$08;		// Group Execute Trigger
	LLO	=$11;		// Local Lock Out
	DCL	=$14;		// Device Clear
	SPE	=$18;		// Serial Poll Enable
	SPD	=$19;		// Serial Poll Disable
	PPC	=$05;		// Parallel Poll Config
	PPE	=$60;		// Parallel Poll Enable
	PPZ	=$70;		// Parallel Poll Disable
	PPU	=$15;		// Parallel Poll Unconfig
	TCT	=$09;		// Take Control (XXX)
	//-------------------------------------
	// GPIBð擾
	//-------------------------------------
	STS_IFC	=$01;		// IFC
	STS_DCAS=$02;		// DeviceClear
	STS_UNC	=$04;		// Ppoll,TCT etc
	STS_ERR	=$08;		// Error
	STS_GET	=$10;		// GET
	STS_SPAS=$20;		// Spoll
	STS_END	=$40;		// END
	STS_REM	=$00;		// Remote
	STS_LLO	=$00;		// LLO
	STS_TLK	=$00;		// Talker
	STS_LSN	=$00;		// Listener
	STS_ATN	=$00;		// ATN
	STS_SRQ	=$00;		// SRQ
	STS_REN	=$00;		// REN
	//-------------------------------------
	// GPIB֘AҰw͈
	//-------------------------------------
	ADDR_MIN				=0;				// ŏGPIBڽ
	ADDR_MAX				=30;			// ő    "
	TIMEOUT_DEFAULT	=2000;		// ѱ̫
	TIMEOUT_MAX			=60000;		// ѱčől
	//-------------------------------------
	// GPIBӰގw
	//-------------------------------------
	MODE_SYSCON			=1;				// Ѻ۰Ӱ
	MODE_TLKLSN			=0;				// İؽӰ
	//-------------------------------------
	// Ӱގw
	//-------------------------------------
	DELIM_CRLF			=1;				// CR + LF(̫)
	DELIM_CR				=2;				// CR
	DELIM_LF				=3;				// LF
	DELIM_NO				=0;				// NOTHING
	//-------------------------------------
	// EOIӰގw
	//-------------------------------------
	EOI_ON					=1;				// t(̫)
	EOI_OFF					=0;				// Ȃ
	//-------------------------------------
	// ̑萔
	//-------------------------------------
	GP02_DLL_NAME		= 'axpGP02.dll';	// DLĻٖ
	GP02_SOCKET_AUTO=WORD(not 0);
	GP02_MAX_SOCKETS=16;
	//-------------------------------------
	// ؿ\
	//-------------------------------------
	GP02_NMAX_MEM	=	9;
	GP02_NMAX_IO	= 20;
	GP02_NMAX_IRQ	=	7;
	GP02_NMAX_DMA	=	7;
type
	TGP02RESOURCE = record
		dwNumMemWindows:															DWORD;	// س޳(gp)
		dwMemBase:			array [1 .. GP02_NMAX_MEM] of	DWORD;	// س޳ްڽ(gp)
		dwMemLength:		array [1 .. GP02_NMAX_MEM] of	DWORD;	// س޳(gp)
		dwMemAttrib:		array [1 .. GP02_NMAX_MEM] of	DWORD;	// س޳(gp)
		dwNumIOPorts:																	DWORD;	// I/O߰Đ
		dwIOPortBase:		array [1 .. GP02_NMAX_IO]	 of	DWORD;	// I/O߰ްڽ
		dwIOPortLength: array [1 .. GP02_NMAX_IO]	 of	DWORD;	// I/O߰Ē
		dwNumIRQs:																		DWORD;	// IRQ(gp)
		dwIRQRegisters: array [1 .. GP02_NMAX_IRQ] of	DWORD;	// IRQؽ(gp)
		dwIRQAttrib:		array [1 .. GP02_NMAX_IRQ] of	DWORD;	// IRQؽ(gp)
		dwNumDMAs:																		DWORD;	// DMAِ(gp)
		dwDMALst:				array [1 .. GP02_NMAX_DMA] of	DWORD;	// DMAؽ(gp)
		dwDMAAttrib:		array [1 .. GP02_NMAX_DMA] of	DWORD;	// DMAّؽ(gp)
		dwReserved1:		array [1 .. 3] 						 of	DWORD;	// \(gp)
	end;
	PGP02RESOURCE = ^TGP02RESOURCE;

//-------------------------------------
// J֐
//-------------------------------------
// DLL ۰
function Gp02wDllOpen: Boolean;
// DLL ۰
function Gp02wDllClose: Boolean;
// װގ擾
function Gp02wGetLastError(wLogSocket:WORD): DWORD;
// GPIBð̎擾
function Gp02wGetStatus(wLogSocket:WORD): DWORD;
// DLL,޲ײްްޮݔԍ擾
function Gp02wGetVersion(var pdwDllVersion:DWORD; var pdwDriverVersion:DWORD): Boolean;
// ޲̎gp錾
function Gp02wCreate(var pwLogSocket:WORD): Boolean;
// ޲J
function Gp02wClose(wLogSocket:WORD): Boolean;
// ؿ擾
function Gp02wGetResource(wLogSocket:WORD; pResInfo:PGP02RESOURCE): Boolean;
// GPIB
function Gp02wInit(wLogSocket,wGpibAddr,wGpibMode:Word; dwFifoSize:DWord): Boolean;
// GPIBѱĐݒ
function Gp02wSetTime(wLogSocket:Word; dwTimeoutCnt:DWord): Boolean;
// EOIݒ
function Gp02wSetEos(wLogSocket,wDlmMode,wEoiMode:Word): Boolean;
// GPIBޑM(۰חp)
function Gp02wSendCmd(wLogSocket:Word; var paSendBuf:array of Byte; dwSendBytes:DWord): Boolean;
// IFCM(۰חp)
function Gp02wIfc(wLogSocket:Word): Boolean;
// RENײ݂̐ݒ(۰חp)
function Gp02wRen(wLogSocket,wRenLine:Word): Boolean;
// DCLM(۰חp)
function Gp02wDcl(wLogSocket:Word): Boolean;
// w@ւSDCM(۰חp)
function Gp02wSdc(wLogSocket,wLsnAdrs:Word): Boolean;
// ̎w@ւްM(۰חp)
function Gp02wSendDataCN(wLogSocket:Word; var pwLsnAdrsList:array of Word; wLsnAdrsCnt:Word; var pbSendBuff:array of Byte; dwDataCnt:DWord): Boolean;
// w@ւްM(۰חp)
function Gp02wSendDataC(wLogSocket,wLsnAdrs:Word; var pbSendBuff:array of Byte; dwDataCnt:DWord): Boolean;
// ްM(ڰޗp)
function Gp02wSendDataS(wLogSocket:Word; var pbSendBuff:array of Byte; dwDataCnt:DWord): Boolean;
// w@킩ްM(۰חp)
function Gp02wRecvDataC(wLogSocket,wTlkAdrs:Word; var pbRecvBuff:array of Byte; var pdwDataCnt:DWord): Boolean;
// ްM(ڰޗp)
function Gp02wRecvDataS(wLogSocket:Word; var pbRecvBuff:array of Byte; var pdwDataCnt:DWord): Boolean;
// @ް](۰חp)
function Gp02wTransDataN(wLogSocket,wTlkAdrs:Word; var pwLsnAdrsList:array of Word; wLsnAdrsCnt:Word): Boolean;
// @ް](۰חp)
function Gp02wTransData(wLogSocket,wTlkAdrs,wLsnAdrs:Word): Boolean;
// SRQײ݂ƽð޲Đݒ(ڰޗp)
function Gp02wSetSrqLine(wLogSocket:Word; bStsByte:Byte): Boolean;
// SRQײ݂̏Ԕ(۰חp)
function Gp02wGetSrqLine(wLogSocket:Word; var pwSrqLine:Word): Boolean;
// رَ߰s(۰חp)
function Gp02wSpoll(wLogSocket,wPollAdrs:Word; var pbStsByte:Byte): Boolean;
// َ߰s(۰חp)
function Gp02wPpoll(wLogSocket:Word; var pbDioLine:Byte): Boolean;
// ٍ߰\(۰חp)
function Gp02wPpollConfig(wLogSocket,wLsnAdrs:Word; bDioLine:Byte; bSbit:Byte): Boolean;
// w@ٍ߰\(۰חp)
function Gp02wPpollUnConfig(wLogSocket,wLsnAdrs:Word): Boolean;
// S@ٍ߰\(۰חp)
function Gp02wPpollUnConfigAll(wLogSocket:Word): Boolean;
// ߰ىݒ(ڰޗp)
function Gp02wPpollRespModeSet(wLogSocket,wPMode:Word): Boolean;

//-------------------------------------
// (STATIC)ϐȂ
//-------------------------------------
implementation

{$J+}	// ^t萔̕ύX\߲׎w
const
	hDLL: THandle = 0;

type
	TGp02GetLastError = function(wLogSocket:WORD): DWORD; stdcall;
	TGp02GetStatus = function(wLogSocket:WORD): DWORD; stdcall;
	TGp02GetVersion = function(var pdwDllVersion:DWORD; var pdwDriverVersion:DWORD): Boolean; stdcall;
	TGp02Create = function(var pwLogSocket): Boolean; stdcall;
	TGp02Close = function(wLogSocket:WORD): Boolean; stdcall;
	TGp02GetResource = function(wLogSocket:WORD; pResInfo:PGP02RESOURCE): Boolean; stdcall;
	TGp02Init = function(wLogSocket,wGpibAddr,wGpibMode:Word; dwFifoSize:DWord): Boolean; stdcall;
	TGp02SetTime = function(wLogSocket:Word; dwTimeoutCnt:DWord): Boolean; stdcall;
	TGp02SetEos = function(wLogSocket,wDlmMode,wEoiMode:Word): Boolean; stdcall;
	TGp02SendCmd = function(wLogSocket:Word; paSendBuf:PChar; dwSendBytes:DWord): Boolean; stdcall;
	TGp02Ifc = function(wLogSocket:Word): Boolean; stdcall;
	TGp02Ren = function(wLogSocket,wRenLine:Word): Boolean; stdcall;
	TGp02Dcl = function(wLogSocket:Word): Boolean; stdcall;
	TGp02Sdc = function(wLogSocket,wLsnAdrs:Word): Boolean; stdcall;
	TGp02SendDataCN = function(wLogSocket:Word; pwLsnAdrsList:PWordArray; wLsnAdrsCnt:Word; pbSendBuff:PChar; dwDataCnt:DWord): Boolean; stdcall;
	TGp02SendDataC = function(wLogSocket,wLsnAdrs:Word; pbSendBuff:PChar; dwDataCnt:DWord): Boolean; stdcall;
	TGp02SendDataS = function(wLogSocket:Word; pbSendBuff:PChar; dwDataCnt:DWord): Boolean; stdcall;
	TGp02RecvDataC = function(wLogSocket,wTlkAdrs:Word; pbRecvBuff:PChar; var pdwDataCnt:DWord): Boolean; stdcall;
	TGp02RecvDataS = function(wLogSocket:Word; pbRecvBuff:PChar; var pdwDataCnt:DWord): Boolean; stdcall;
	TGp02TransDataN = function(wLogSocket,wTlkAdrs:Word; pwLsnAdrsList:PWordArray; wLsnAdrsCnt:Word): Boolean; stdcall;
	TGp02TransData = function(wLogSocket,wTlkAdrs,wLsnAdrs:Word): Boolean; stdcall;
	TGp02SetSrqLine = function(wLogSocket:Word; bStsByte:Byte): Boolean; stdcall;
	TGp02GetSrqLine = function(wLogSocket:Word; var pwSrqLine:Word): Boolean; stdcall;
	TGp02Spoll = function(wLogSocket,wPollAdrs:Word; var pbStsByte:Byte): Boolean; stdcall;
	TGp02Ppoll = function(wLogSocket:Word; var pbDioLine:Byte): Boolean; stdcall;
	TGp02PpollConfig = function(wLogSocket,wLsnAdrs:Word; bDioLine:Byte; bSbit:Byte): Boolean; stdcall;
	TGp02PpollUnConfig = function(wLogSocket,wLsnAdrs:Word): Boolean; stdcall;
	TGp02PpollUnConfigAll = function(wLogSocket:Word): Boolean; stdcall;
	TGp02PpollRespModeSet = function(wLogSocket,wPMode:Word): Boolean; stdcall;

// DLL ߰Ċ֐ڽ̊i[ϐ
var
	pGp02GetLastError:			TGp02GetLastError;
	pGp02GetStatus:					TGp02GetStatus;
	pGp02GetVersion: 				TGp02GetVersion;
	pGp02Create: 						TGp02Create;
	pGp02Close: 						TGp02Close;
	pGp02GetResource: 			TGp02GetResource;
	pGp02Init:							TGp02Init;
	pGp02SetTime:						TGp02SetTime;
	pGp02SetEos:						TGp02SetEos;
	pGp02SendCmd:						TGp02SendCmd;
	pGp02Ifc:								TGp02Ifc;
	pGp02Ren:								TGp02Ren;
	pGp02Dcl:								TGp02Dcl;
	pGp02Sdc:								TGp02Sdc;
	pGp02SendDataCN:				TGp02SendDataCN;
	pGp02SendDataC:					TGp02SendDataC;
	pGp02SendDataS:					TGp02SendDataS;
	pGp02RecvDataC:					TGp02RecvDataC;
	pGp02RecvDataS:					TGp02RecvDataS;
	pGp02TransDataN:				TGp02TransDataN;
	pGp02TransData:					TGp02TransData;
	pGp02SetSrqLine:				TGp02SetSrqLine;
	pGp02GetSrqLine:				TGp02GetSrqLine;
	pGp02Spoll:							TGp02Spoll;
	pGp02Ppoll:							TGp02Ppoll;
	pGp02PpollConfig:				TGp02PpollConfig;
	pGp02PpollUnConfig:			TGp02PpollUnConfig;
	pGp02PpollUnConfigAll:	TGp02PpollUnConfigAll;
	pGp02PpollRespModeSet:	TGp02PpollRespModeSet;

  function _Gp02wGetDllExportFunc: Boolean; forward;

{$J-}

//============================================================================
// 		DLL۰(۰ގʹװƂ)
// 		
// ߂l  True
//				s False
//============================================================================
function Gp02wDllOpen: Boolean;
begin
	Result:=False;
	if hDLL=0 then begin
		hDLL:=LoadLibrary(GP02_DLL_NAME);
		if hDLL<>0 then begin
			if _Gp02wGetDllExportFunc=True then begin
      	Result:=True
			end else Gp02wDllClose;	// DLL֐擾ɎŝDLLN[Y
		end;
	end;
end;
//============================================================================
// 		DLL۰(۰ގʹװƂ)
// 		
// ߂l  True
//				s False
//============================================================================
function Gp02wDllClose: Boolean;
begin
	Result:=False;
	if hDLL<>0 then begin
		if True=FreeLibrary(hDLL) then begin
			hDLL:=0;
			Result:=True;
		end;
	end;
end;
//============================================================================
// 		װނ̎擾
// 		wLogSocket	޲̘_Ĕԍ
// ߂l װ
//============================================================================
function Gp02wGetLastError(wLogSocket:WORD): DWORD;
begin
	if hDLL=0 then Result:=GP02_ERR_WRAPDLL
	else Result:=pGp02GetLastError(wLogSocket)
end;
//============================================================================
// 		GPIBð̎擾
// 		wLogSocket	޲̘_Ĕԍ
// ߂l  True
//				s False
//============================================================================
function Gp02wGetStatus(wLogSocket:WORD): DWORD;
begin
	Result:=pGp02GetStatus(wLogSocket);
end;
//============================================================================
// 		DLL,޲ײްްޮݔԍ擾
// 		pdwDllVersion			DLLްޮݔԍi[̈ւ߲
//				pdwDriverVersion	޲ײްްޮݔԍi[̈ւ߲
// ߂l  True
//				s False
//============================================================================
function Gp02wGetVersion(var pdwDllVersion:DWORD; var pdwDriverVersion:DWORD): Boolean;
begin
	Result:=pGp02GetVersion(pdwDllVersion, pdwDriverVersion);
end;
//============================================================================
// 		޲̎gp錾
// 		pwLogSocket	 	gp޲̘_Ĕԍi[߲
// ߂l  True
//				s False
//============================================================================
function Gp02wCreate(var pwLogSocket:WORD): Boolean;
begin
	Result:=pGp02Create(pwLogSocket);
end;
//============================================================================
// 		޲J
// 		wLogSocket ޲̘_Ĕԍ
// ߂l  True
//				s False
//============================================================================
function Gp02wClose(wLogSocket:WORD): Boolean;
begin
	Result:=pGp02Close(wLogSocket)
end;
//============================================================================
// 		w޲ؿ擾
// 		wLogSocket	޲̘_Ĕԍ
//				pResInfo		ؿi[\߲̂
// ߂l  True
//				s False
//============================================================================
function Gp02wGetResource(wLogSocket:WORD; pResInfo:PGP02RESOURCE): Boolean;
begin
	Result:=pGp02GetResource(wLogSocket, pResInfo)
end;
//============================================================================
// 		
// 		wLogSocket	޲̘_Ĕԍ
//				wGpibAddr   g GP-IB AhX
//				wGpibMode		g GP-IB 샂[h
//				dwFifoSize	Mobt@̑傫
// ߂l  True
//				s False
//============================================================================
function Gp02wInit(wLogSocket,wGpibAddr,wGpibMode:Word; dwFifoSize:DWord): Boolean;
begin
	Result:=pGp02Init(wLogSocket,wGpibAddr,wGpibMode,dwFifoSize);
end;
//============================================================================
// 		GPIBѱĐݒ
// 		wLogSocket		޲̘_Ĕԍ
//				dwTimeoutCnt  ^CAEglBPʂ̓~b0`60000܂ŁB
// ߂l  True
//				s False
//============================================================================
function Gp02wSetTime(wLogSocket:Word; dwTimeoutCnt:DWord): Boolean;
begin
	Result:=pGp02SetTime(wLogSocket,dwTimeoutCnt);
end;
//============================================================================
// 		EOIݒ
// 		wLogSocket	޲̘_Ĕԍ
//				wDlmMode    f~^w
//				wEoiMode    dnh̎gp܂͕sgpw
// ߂l  True
//				s False
//============================================================================
function Gp02wSetEos(wLogSocket,wDlmMode,wEoiMode:Word): Boolean;
begin
	Result:=pGp02SetEos(wLogSocket,wDlmMode,wEoiMode);
end;
//============================================================================
// 		GPIBޑM(۰חp)
// 		wLogSocket	޲̘_Ĕԍ
//				paSendBuf   MR}hobt@̃AhX
//				dwSendBytes	MׂR}h̃oCg
// ߂l  True
//				s False
//============================================================================
function Gp02wSendCmd(wLogSocket:Word; var paSendBuf:array of Byte; dwSendBytes:DWord): Boolean;
begin
	Result:=pGp02SendCmd(wLogSocket,PChar(@paSendBuf),dwSendBytes);
end;
//============================================================================
// 		IFCM(۰חp)
// 		wLogSocket	޲̘_Ĕԍ
// ߂l  True
//				s False
//============================================================================
function Gp02wIfc(wLogSocket:Word): Boolean;
begin
	Result:=pGp02Ifc(wLogSocket);
end;
//============================================================================
// 		RENײ݂̐ݒ(۰חp)
// 		wLogSocket	޲̘_Ĕԍ
//				wRenLine		1(^)/0(U)
// ߂l  True
//				s False
//============================================================================
function Gp02wRen(wLogSocket,wRenLine:Word): Boolean;
begin
	Result:=pGp02Ren(wLogSocket,wRenLine);
end;
//============================================================================
// 		DCLM(۰חp)
// 		wLogSocket	޲̘_Ĕԍ
// ߂l  True
//				s False
//============================================================================
function Gp02wDcl(wLogSocket:Word): Boolean;
begin
	Result:=pGp02Dcl(wLogSocket);
end;
//============================================================================
// 		w@ւSDCM(۰חp)
// 		wLogSocket	޲̘_Ĕԍ
//				wLsnAdrs		XiAhX
// ߂l  True
//				s False
//============================================================================
function Gp02wSdc(wLogSocket,wLsnAdrs:Word): Boolean;
begin
	Result:=pGp02Sdc(wLogSocket,wLsnAdrs);
end;
//============================================================================
// 		̎w@ւްM(۰חp)
// 		wLogSocket		޲̘_Ĕԍ
//				pwLsnAdrsList XiAhXXg̃AhX
//				wLsnAdrsCnt		XiAhX̐
//				pbSendBuff		Mf[^obt@̃AhX
//				dwDataCnt			Mf[^
// ߂l  True
//				s False
//============================================================================
function Gp02wSendDataCN(wLogSocket:Word; var pwLsnAdrsList:array of Word; wLsnAdrsCnt:Word; var pbSendBuff:array of Byte; dwDataCnt:DWord): Boolean;
begin
	Result:=pGp02SendDataCN(wLogSocket,PWordArray(@pwLsnAdrsList),wLsnAdrsCnt,PChar(@pbSendBuff),dwDataCnt);
end;
//============================================================================
// 		w@ւްM(۰חp)
// 		wLogSocket	޲̘_Ĕԍ
//				wLsnAdrs		XiAhX
//				pbSendBuff	Mf[^obt@̃AhX
//				dwDataCnt   Mf[^
// ߂l  True
//				s False
//============================================================================
function Gp02wSendDataC(wLogSocket,wLsnAdrs:Word; var pbSendBuff:array of Byte; dwDataCnt:DWord): Boolean;
begin
	Result:=pGp02SendDataC(wLogSocket,wLsnAdrs,PChar(@pbSendBuff),dwDataCnt);
end;
//============================================================================
// 		ްM(ڰޗp)
// 		wLogSocket	޲̘_Ĕԍ
//				pbSendBuff	Mf[^obt@̃AhX
//				dwDataCnt		Mf[^
// ߂l  True
//				s False
//============================================================================
function Gp02wSendDataS(wLogSocket:Word; var pbSendBuff:array of Byte; dwDataCnt:DWord): Boolean;
begin
	Result:=pGp02SendDataS(wLogSocket,PChar(@pbSendBuff),dwDataCnt);
end;
//============================================================================
// 		w@킩ްM(۰חp)
// 		wLogSocket	޲̘_Ĕԍ
//				wTlkAdrs		g[JAhX
//				pbRecvBuff	Mf[^obt@̃AhX
//				pdwDataCnt	Mf[^w肷ϐ̃AhX
// ߂l  True
//				s False
//============================================================================
function Gp02wRecvDataC(wLogSocket,wTlkAdrs:Word; var pbRecvBuff:array of Byte; var pdwDataCnt:DWord): Boolean;
begin
	Result:=pGp02RecvDataC(wLogSocket,wTlkAdrs,PChar(@pbRecvBuff),pdwDataCnt);
end;
//============================================================================
// 		ްM(ڰޗp)
// 		wLogSocket	޲̘_Ĕԍ
//				pbRecvBuff  Mf[^obt@̃AhX
//				pdwDataCnt  Mf[^w肷ϐ̃AhX
// ߂l  True
//				s False
//============================================================================
function Gp02wRecvDataS(wLogSocket:Word; var pbRecvBuff:array of Byte; var pdwDataCnt:DWord): Boolean;
begin
	Result:=pGp02RecvDataS(wLogSocket,PChar(@pbRecvBuff),pdwDataCnt);
end;
//============================================================================
// 		@ް](۰חp)
// 		wLogSocket		޲̘_Ĕԍ
//				wTlkAdrs      g[JAhX
//				pwLsnAdrsList	XiAhXXg̃AhX
//				wLsnAdrsCnt		XiAhX̐
// ߂l  True
//				s False
//============================================================================
function Gp02wTransDataN(wLogSocket,wTlkAdrs:Word; var pwLsnAdrsList:array of Word; wLsnAdrsCnt:Word): Boolean;
begin
	Result:=pGp02TransDataN(wLogSocket,wTlkAdrs,PWordArray(@pwLsnAdrsList),wLsnAdrsCnt);
end;
//============================================================================
// 		@ް](۰חp)
// 		wLogSocket	޲̘_Ĕԍ
//				wTlkAdrs		g[JAhX
//				wLsnAdrs		XiAhX
// ߂l  True
//				s False
//============================================================================
function Gp02wTransData(wLogSocket,wTlkAdrs,wLsnAdrs:Word): Boolean;
begin
	Result:=pGp02TransData(wLogSocket,wTlkAdrs,wLsnAdrs);
end;
//============================================================================
// 		SRQײ݂ƽð޲Đݒ(ڰޗp)
// 		wLogSocket	޲̘_Ĕԍ
//				bStsByte		Xe[^XoCgl
// ߂l  True
//				s False
//============================================================================
function Gp02wSetSrqLine(wLogSocket:Word; bStsByte:Byte): Boolean;
begin
	Result:=pGp02SetSrqLine(wLogSocket,bStsByte);
end;
//============================================================================
// 		SRQײ݂̏Ԕ(۰חp)
// 		wLogSocket	޲̘_Ĕԍ
//				pwSrqLine		rqpCԂi[ϐ̃AhX
// ߂l  True
//				s False
//============================================================================
function Gp02wGetSrqLine(wLogSocket:Word; var pwSrqLine:Word): Boolean;
begin
	Result:=pGp02GetSrqLine(wLogSocket,pwSrqLine);
end;
//============================================================================
// 		رَ߰s(۰חp)
// 		wLogSocket	޲̘_Ĕԍ
//				wPollAdrs		|[ÕAhX
//				pbStsByte		Xe[^XoCgi[ϐ̃AhX
// ߂l  True
//				s False
//============================================================================
function Gp02wSpoll(wLogSocket,wPollAdrs:Word; var pbStsByte:Byte): Boolean;
begin
	Result:=pGp02Spoll(wLogSocket,wPollAdrs,pbStsByte);
end;
//============================================================================
// 		َ߰s(۰חp)
// 		wLogSocket	޲̘_Ĕԍ
//				pbDioLine   chnCi[ϐ̃AhX
// ߂l  True
//				s False
//============================================================================
function Gp02wPpoll(wLogSocket:Word; var pbDioLine:Byte): Boolean;
begin
	Result:=pGp02Ppoll(wLogSocket,pbDioLine);
end;
//============================================================================
// 		ٍ߰\(۰חp)
// 		wLogSocket	޲̘_Ĕԍ
//				wLsnAdrs		\@AhX
//				bDioLine    @tDIOCԍiO`ṼrbgԍŎwj
//				bSbit				ZXrbg̎wiO܂͂Pj
// ߂l  True
//				s False
//============================================================================
function Gp02wPpollConfig(wLogSocket,wLsnAdrs:Word; bDioLine:Byte; bSbit:Byte): Boolean;
begin
	Result:=pGp02PpollConfig(wLogSocket,wLsnAdrs,bDioLine,bSbit);
end;
//============================================================================
// 		w@ٍ߰\(۰חp)
// 		wLogSocket	޲̘_Ĕԍ
//				wLsnAdrs		\@AhX
// ߂l  True
//				s False
//============================================================================
function Gp02wPpollUnConfig(wLogSocket,wLsnAdrs:Word): Boolean;
begin
	Result:=pGp02PpollUnConfig(wLogSocket,wLsnAdrs);
end;
//============================================================================
// 		S@ٍ߰\(۰חp)
// 		wLogSocket	޲̘_Ĕԍ
// ߂l  True
//				s False
//============================================================================
function Gp02wPpollUnConfigAll(wLogSocket:Word): Boolean;
begin
	Result:=pGp02PpollUnConfigAll(wLogSocket);
end;
//============================================================================
// 		߰ىݒ(ڰޗp)
// 		wLogSocket	޲̘_Ĕԍ
//				wPMode			p|[ւ̉@
// ߂l  True
//				s False
//============================================================================
function Gp02wPpollRespModeSet(wLogSocket,wPMode:Word): Boolean;
begin
	Result:=pGp02PpollRespModeSet(wLogSocket,wPMode);
end;
//----------------------------------------------------------------------------
// 	  DLL߰Ċ֐ڽ̎擾
// 	  
// ߂l  True
//		  	s False
//----------------------------------------------------------------------------
function _Gp02wGetDllExportFunc: Boolean;
begin
	Result:=False;
	pGp02GetLastError:=GetProcAddress(hDLL, 'Gp02GetLastError');
	if @pGp02GetLastError=nil then Exit;
	pGp02GetStatus:=GetProcAddress(hDLL, 'Gp02GetStatus');
	if @pGp02GetStatus=nil then Exit;
	pGp02GetVersion:=GetProcAddress(hDLL, 'Gp02GetVersion');
	if @pGp02GetVersion=nil then Exit;
	pGp02Create:=GetProcAddress(hDLL, 'Gp02Create');
	if @pGp02Create=nil then Exit;
	pGp02Close:=GetProcAddress(hDLL, 'Gp02Close');
	if @pGp02Close=nil then Exit;
	pGp02GetResource:=GetProcAddress(hDLL, 'Gp02GetResource');
	if @pGp02GetResource=nil then Exit;
	pGp02Init:=GetProcAddress(hDLL, 'Gp02Init');
	if @pGp02Init=nil then Exit;
	pGp02SetTime:=GetProcAddress(hDLL, 'Gp02SetTime');
	if @pGp02SetTime=nil then Exit;
	pGp02SetEos:=GetProcAddress(hDLL, 'Gp02SetEos');
	if @pGp02SetEos=nil then Exit;
	pGp02SendCmd:=GetProcAddress(hDLL, 'Gp02SendCmd');
	if @pGp02SendCmd=nil then Exit;
	pGp02Ifc:=GetProcAddress(hDLL, 'Gp02Ifc');
	if @pGp02Ifc=nil then Exit;
	pGp02Ren:=GetProcAddress(hDLL, 'Gp02Ren');
	if @pGp02Ren=nil then Exit;
	pGp02Dcl:=GetProcAddress(hDLL, 'Gp02Dcl');
	if @pGp02Dcl=nil then Exit;
	pGp02Sdc:=GetProcAddress(hDLL, 'Gp02Sdc');
	if @pGp02Sdc=nil then Exit;
	pGp02SendDataCN:=GetProcAddress(hDLL, 'Gp02SendDataCN');
	if @pGp02SendDataCN=nil then Exit;
	pGp02SendDataC:=GetProcAddress(hDLL, 'Gp02SendDataC');
	if @pGp02SendDataC=nil then Exit;
	pGp02SendDataS:=GetProcAddress(hDLL, 'Gp02SendDataS');
	if @pGp02SendDataS=nil then Exit;
	pGp02RecvDataC:=GetProcAddress(hDLL, 'Gp02RecvDataC');
	if @pGp02RecvDataC=nil then Exit;
	pGp02RecvDataS:=GetProcAddress(hDLL, 'Gp02RecvDataS');
	if @pGp02RecvDataS=nil then Exit;
	pGp02TransDataN:=GetProcAddress(hDLL, 'Gp02TransDataN');
	if @pGp02TransDataN=nil then Exit;
	pGp02TransData:=GetProcAddress(hDLL, 'Gp02TransData');
	if @pGp02TransData=nil then Exit;
	pGp02SetSrqLine:=GetProcAddress(hDLL, 'Gp02SetSrqLine');
	if @pGp02SetSrqLine=nil then Exit;
	pGp02GetSrqLine:=GetProcAddress(hDLL, 'Gp02GetSrqLine');
	if @pGp02GetSrqLine=nil then Exit;
	pGp02Spoll:=GetProcAddress(hDLL, 'Gp02Spoll');
	if @pGp02Spoll=nil then Exit;
	pGp02Ppoll:=GetProcAddress(hDLL, 'Gp02Ppoll');
	if @pGp02Ppoll=nil then Exit;
	pGp02PpollConfig:=GetProcAddress(hDLL, 'Gp02PpollConfig');
	if @pGp02PpollConfig=nil then Exit;
	pGp02PpollUnConfig:=GetProcAddress(hDLL, 'Gp02PpollUnConfig');
	if @pGp02PpollUnConfig=nil then Exit;
	pGp02PpollUnConfigAll:=GetProcAddress(hDLL, 'Gp02PpollUnConfigAll');
	if @pGp02PpollUnConfigAll=nil then Exit;
	pGp02PpollRespModeSet:=GetProcAddress(hDLL, 'Gp02PpollRespModeSet');
	if @pGp02PpollRespModeSet=nil then Exit;
	// SĂ DLL ߰Ċ֐ڽ擾nj
	Result:=True;
end;

end.

