VERSION 5.00
Begin VB.Form Sample 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows ̊l
End
Attribute VB_Name = "Sample"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'
'       Gp02s.frm
'       99/05/20
'       bp[֐̃CTv
'

Option Explicit

Private Const szGP02 = "AXP-GP02"
Private Const MAXBUFF = 4096                ' Mp̃obt@MAX
Private Const MYADRS = 0                    ' GPIBAhX
Private Const PRTADRS = 1                   ' GPIBAhX

Private Sub Form_Load()
    Dim strbuf As String
    Dim dwDllVer As Long, dwDrvVer As Long  ' DLL, Drivero[W
    Dim bResult As Boolean                  ' 
    Dim wLogSocket As Integer               ' foCXi[
    Dim wGpibAdrs As Integer                ' haAhX
    Dim wGpibMode As Integer                ' ha[h
    Dim dwFifoSize As Long                  ' haobt@TCY
    Dim dwTimeout As Long                   ' ^CAEgl
    Dim ri As GP02_RESOURCE                 ' \[X
    Dim Buff(1 To MAXBUFF) As Byte          ' Mp̃obt@
    Dim dwDataCnt As Long                   ' Mf[^
    Dim wSrqLine As Integer                 ' rqpC
    Dim bStsByte As Byte                    ' Xe[^XoCg
    Dim i As Long                           ' [vpϐ

    '---------------------------------------------------------------------------
    ' DLL̎gp錾
    '---------------------------------------------------------------------------
    If Gp02wDllOpen() = False Then
        ErrorMessage (GP02_SOCKET_AUTO)
        Exit Sub
    End If

    ResultMessage ("DLL[h܂B")

    '---------------------------------------------------------------------------
    ' DLL,VxD̃o[Wԍ擾
    '---------------------------------------------------------------------------
    If Gp02wGetVersion(dwDllVer, dwDrvVer) = False Then
        ErrorMessage (GP02_SOCKET_AUTO)
        Exit Sub
    End If

    strbuf = "o[Wԍ擾" + Chr(10) + _
             "DLL Version: &H" + Hex(dwDllVer) + Chr(10) + _
             "Drv Version: &H" + Hex(dwDrvVer)
       
    ResultMessage (strbuf)

    '---------------------------------------------------------------------------
    ' foCX̎gp錾
    '---------------------------------------------------------------------------
    wLogSocket = GP02_SOCKET_AUTO           ' gp̃foCXT܂B
    bResult = Gp02wCreate(wLogSocket)       ' ꍇA̎̃foCXi[܂B

    If bResult = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If

    strbuf = "foCX̎gp錾" + Chr(10) + Chr(10) + _
             "LogSocket: " + Str(wLogSocket)

    ResultMessage (strbuf)

    '---------------------------------------------------------------------------
    ' \[X擾
    '---------------------------------------------------------------------------
    If Gp02wGetResource(wLogSocket, ri) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If

    strbuf = "\[X擾" + Chr(10) + _
             "NumPorts   : " + Str(ri.dwIOPortLength(1)) + Chr(10) + _
             "IO Address : &H" + Hex(ri.dwIOPortBase(1)) + _
             "-&H" + Hex(ri.dwIOPortBase(1) + ri.dwIOPortLength(1) - 1) + Chr(10) + _
             "IRQ        : " + Str(ri.dwIRQRegisters(1))

    ResultMessage (strbuf)

    '---------------------------------------------------------------------------
    ' AXP-GP02̏
    '---------------------------------------------------------------------------
    wGpibAdrs = MYADRS              ' ̂haAhX
    wGpibMode = MODE_SYSCON         ' Rg[ɂȂ
    dwFifoSize = MAXBUFF            ' FIFOobt@TCYw

    If Gp02wInit(wLogSocket, wGpibAdrs, wGpibMode, dwFifoSize) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If

    strbuf = "AXP-GP02̏" + Chr(10) + Chr(10) + _
             "My IB-Address: " + Str(wGpibAdrs) + Chr(10) + _
             "IB-Mode: " + Str(wGpibMode) + Chr(10) + _
             "FifoSize: " + Str(dwFifoSize)

    ResultMessage (strbuf)

    '---------------------------------------------------------------------------
    ' GP-IB ̃^CAEgݒ
    '---------------------------------------------------------------------------
    dwTimeout = 3000        ' ^CAEgl=Rb
    
    If Gp02wSetTime(wLogSocket, dwTimeout) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If

    strbuf = "GP-IB̃^CAEgݒ" + Chr(10) + Chr(10) + _
             "Timeout: " + Str(dwTimeout) + _
             "mSec"

    ResultMessage (strbuf)

    '---------------------------------------------------------------------------
    ' f~^Ƃdnhݒ
    '---------------------------------------------------------------------------
    If Gp02wSetEos(wLogSocket, DELIM_CRLF, EOI_ON) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If

    strbuf = "f~^Ƃdnhݒ" + Chr(10) + Chr(10) + _
             ": CR+LF" + Chr(10) + _
             "EOI: On"

    ResultMessage (strbuf)

    '---------------------------------------------------------------------------
    ' heb̑MiRg[pj
    '---------------------------------------------------------------------------
    If Gp02wIfc(wLogSocket) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If

    strbuf = "heb̑M"

    ResultMessage (strbuf)

    '---------------------------------------------------------------------------
    ' w@ւ̃f[^MiRg[pj
    '---------------------------------------------------------------------------
    wGpibAdrs = PRTADRS                     ' XîhaAhX
    dwDataCnt = 10                          ' Mf[^
    
    For i = 1 To 10
        Buff(i) = Asc("0") + (i - 1)
    Next i

    If Gp02wSendDataC(wLogSocket, wGpibAdrs, Buff, dwDataCnt) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If

    strbuf = "w@ւ̃f[^M"

    ResultMessage (strbuf)

    '---------------------------------------------------------------------------
    ' w@킩̃f[^MiRg[pj
    '---------------------------------------------------------------------------
    wGpibAdrs = PRTADRS             ' g[ĴhaAhX
    dwDataCnt = 50                  ' Mf[^
    
    If Gp02wRecvDataC(wLogSocket, wGpibAdrs, Buff, dwDataCnt) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If

    strbuf = "w@킩̃f[^M" + Chr(10) + Chr(10) + _
             "DataCnt: " + Str(dwDataCnt) + Chr(10) + _
             "Data   :"
             
    For i = 1 To MAXBUFF
        strbuf = strbuf + Chr(Buff(i))
    Next
    
             
    ResultMessage (strbuf)

    '---------------------------------------------------------------------------
    ' rqpC̏ԔiRg[pj
    '---------------------------------------------------------------------------
    If Gp02wGetSrqLine(wLogSocket, wSrqLine) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If

    strbuf = "rqpC̏Ԕ" + Chr(10) + Chr(10) + _
             "SRQline: " + Str(wSrqLine)

    ResultMessage (strbuf)

    '---------------------------------------------------------------------------
    ' VA|[siRg[pj
    '---------------------------------------------------------------------------
    If wSrqLine = 1 Then
        wGpibAdrs = PRTADRS                             ' VA|[haAhX
        If Gp02wSpoll(wLogSocket, wGpibAdrs, bStsByte) = False Then
            ErrorMessage (wLogSocket)
            Exit Sub
        End If

        strbuf = "VA|[s" + Chr(10) + Chr(10) + _
                 "STS Byte: " + Hex(bStsByte)

        ResultMessage (strbuf)
    End If

    '---------------------------------------------------------------------------
    ' foCX̎gpI
    '---------------------------------------------------------------------------
    If Gp02wClose(wLogSocket) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If

    strbuf = "foCX̎gpI" + Chr(10) + Chr(10) + _
             "LogSocket: " + Str(wLogSocket)

    ResultMessage (strbuf)

    '---------------------------------------------------------------------------
    ' DLL̃A[h
    '---------------------------------------------------------------------------
    Gp02wDllClose

    Unload Me

End Sub

'---------------------------------------------------------------------------
' ʂ\
'---------------------------------------------------------------------------
Private Sub ResultMessage(lpszbuf As String)

    MsgBox lpszbuf, vbOKOnly + vbInformation

End Sub

'---------------------------------------------------------------------------
' G[bZ[W\ďI
'---------------------------------------------------------------------------
Private Sub ErrorMessage(wLogSocket As Integer)

    Dim dwRes As Long
    Dim szbuf As String

    dwRes = Gp02wGetLastError(wLogSocket)

    Select Case dwRes
    Case GP02_ERR_WRAPDLL
        szbuf = "DLL Load error"

    Case Else
        szbuf = "AXP-GP02 error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(dwRes)
    End Select

    MsgBox szbuf, vbOKOnly + vbCritical

    ' I
    Gp02wClose (wLogSocket)
    Gp02wDllClose

End Sub

