//============================================================================
// bp[֐̃CTv
//----------------------------------------------------------------------------
// Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//============================================================================
#define	STRICT
#include <windows.h>
#include <tchar.h>
#include "axpgp02w.h"

#define MAXBUFF	4096	// Mp̃obt@l`w
#define MYADRS 	0		// GPIBAhX
#define PRTADRS	3  	    // GPIBAhX

static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSocket);


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
												LPSTR lpCmdLine, int nCmdShow)
{
	TCHAR szbuf[1024];
	DWORD	dwDLLVer, dwDrvVer;	// DLL, Drivero[W
	BOOL	bResult;			// 
	WORD	wLogSocket;			// foCXi[
	WORD	wGpibAdrs;			// haAhX
	WORD	wGpibMode;			// ha[h
	DWORD	dwFifoSize;			// haobt@TCY
	DWORD	dwTimeout;			// ^CAEgl
	GP02_RESOURCE	ri;			// \[X
	BYTE	Buff[MAXBUFF];		// Mp̃obt@
	DWORD	dwDataCnt;			// Mf[^
	WORD	wSrqLine;			// rqpC
	BYTE	bStsByte;			// Xe[^XoCg
	WORD	i;					// [vpϐ

	//---------------------------------------------------------------------------
	// DLL̎gp錾
	//---------------------------------------------------------------------------
	if ( Gp02wDllOpen() == FALSE ) {
		ErrorMessage(GP02_SOCKET_AUTO);
		return 1;
	}
	ResultMessage("DLL[h܂B");
	//---------------------------------------------------------------------------
	// DLL,VxD̃o[Wԍ擾
	//---------------------------------------------------------------------------
	if ( Gp02wGetVersion(&dwDLLVer, &dwDrvVer) == FALSE ) {
		ErrorMessage(GP02_SOCKET_AUTO);
		return 1;
	}
	wsprintf(szbuf, _T("o[Wԍ擾\n")
					_T("DLL Version: %08lxh\n")
					_T("Drv Version: %08lxh"), dwDLLVer, dwDrvVer );
	ResultMessage(szbuf);
	//---------------------------------------------------------------------------
	// foCX̎gp錾
	//---------------------------------------------------------------------------
	wLogSocket = GP02_SOCKET_AUTO;		// gp̃foCXT܂B
	bResult = Gp02wCreate(&wLogSocket);	// ꍇA̎̃foCXi[܂B
	if ( bResult == FALSE ) {
		ErrorMessage(GP02_SOCKET_AUTO);
		return 1;
	}
	wsprintf(szbuf, _T("foCX̎gp錾\n\n")
					_T("LogSocket: %2d"), wLogSocket);
	ResultMessage(szbuf);
	//---------------------------------------------------------------------------
	// \[X擾
	//---------------------------------------------------------------------------
	if ( Gp02wGetResource(wLogSocket, &ri) == FALSE ) {
		ErrorMessage(wLogSocket);
		return 1;
	}
	wsprintf(szbuf, _T("\[X擾\n")
					_T("NumPorts   : %2d\n")
					_T("IO Address : %04xH - %04xH\n")
					_T("IRQ        : %2d") ,
					ri.dwIOPortLength[0],ri.dwIOPortBase[0],ri.dwIOPortBase[0] + ri.dwIOPortLength[0] - 1,
					ri.dwIRQRegisters[0] );
	ResultMessage(szbuf);
	//---------------------------------------------------------------------------
	// AXP-GP02̏
	//---------------------------------------------------------------------------
	wGpibAdrs = MYADRS;			// ̂haAhX
	wGpibMode = MODE_SYSCON;	// Rg[ɂȂ
  	dwFifoSize = MAXBUFF;		// FIFOobt@TCYw
	if ( Gp02wInit(wLogSocket,wGpibAdrs,wGpibMode,dwFifoSize) == FALSE ) {
		ErrorMessage(wLogSocket);
		return 1;
	}
	wsprintf(szbuf, _T("AXP-GP02̏\n\n")
					_T("My IB-Address: %2d\n")
					_T("IB-Mode: %d\n")
					_T("FifoSize: %d") , 
					wGpibAdrs,wGpibMode,dwFifoSize );
	ResultMessage(szbuf);
	//---------------------------------------------------------------------------
	// GP-IB ̃^CAEgݒ
	//---------------------------------------------------------------------------
	dwTimeout = 3000;	// ^CAEgl=Rb
	if ( Gp02wSetTime(wLogSocket,dwTimeout) == FALSE ) {
		ErrorMessage(wLogSocket);
		return 1;
	}
	wsprintf(szbuf, _T("GP-IB̃^CAEgݒ\n\n")
					_T("Timeout: %dmSec\n") , dwTimeout);
	ResultMessage(szbuf);
	//---------------------------------------------------------------------------
	// f~^Ƃdnhݒ
	//---------------------------------------------------------------------------
	if ( Gp02wSetEos(wLogSocket,DELIM_CRLF,EOI_ON) == FALSE) {
		ErrorMessage(wLogSocket);
		return 1;
	}
	wsprintf(szbuf, _T("f~^Ƃdnhݒ\n\n") _T(": CR+LF\n") _T("EOI: On"));
	ResultMessage(szbuf);
	//---------------------------------------------------------------------------
	// heb̑MiRg[pj
	//---------------------------------------------------------------------------
	if ( Gp02wIfc(wLogSocket) == FALSE ) {
		ErrorMessage(wLogSocket);
		return 1;
	}
	wsprintf(szbuf, _T("heb̑M"));
	ResultMessage(szbuf);
	//---------------------------------------------------------------------------
	// w@ւ̃f[^MiRg[pj
	//---------------------------------------------------------------------------
	wGpibAdrs = PRTADRS;			// XîhaAhX
  	dwDataCnt = 10;					// Mf[^
	for (i=0; i<=9; i++)
		Buff[i] = '0' + i;
	if ( Gp02wSendDataC(wLogSocket,wGpibAdrs,Buff,dwDataCnt) == FALSE ) {
		ErrorMessage(wLogSocket);
		return 1;
	}
	wsprintf(szbuf, _T("w@ւ̃f[^M"));
	ResultMessage(szbuf);
	//---------------------------------------------------------------------------
	// w@킩̃f[^MiRg[pj
	//---------------------------------------------------------------------------
	wGpibAdrs = PRTADRS;			// g[ĴhaAhX
	dwDataCnt = 50;					// Mf[^
	if ( Gp02wRecvDataC(wLogSocket,wGpibAdrs,Buff,&dwDataCnt) == FALSE ) {
		ErrorMessage(wLogSocket);
		return 1;
	}
	Buff[dwDataCnt] = 0;
	wsprintf(szbuf, _T("w@킩̃f[^M\n\n")
					_T("DataCnt: %d\n")
					_T("Data   : %s") ,
					dwDataCnt,(PCHAR *)&Buff );
	ResultMessage(szbuf);
	//---------------------------------------------------------------------------
	// rqpC̏ԔiRg[pj
	//---------------------------------------------------------------------------
	if ( Gp02wGetSrqLine(wLogSocket,&wSrqLine) == FALSE ) {
		ErrorMessage(wLogSocket);
		return 1;
	}
	wsprintf(szbuf, _T("rqpC̏Ԕ\n\n")
					_T("SRQline: %d") , wSrqLine);
	ResultMessage(szbuf);
	//---------------------------------------------------------------------------
	// VA|[siRg[pj
	//---------------------------------------------------------------------------
	if ( wSrqLine == 1 ) {
		wGpibAdrs = PRTADRS;				// VA|[haAhX
		if ( Gp02wSpoll(wLogSocket,wGpibAdrs,&bStsByte) == FALSE ) {
			ErrorMessage(wLogSocket);
			return 1;
		}
		wsprintf(szbuf, _T("VA|[s\n\n")
						_T("STS Byte: %x") , bStsByte);
		ResultMessage(szbuf);
	}
	//---------------------------------------------------------------------------
	// foCX̎gpI
	//---------------------------------------------------------------------------
	if ( Gp02wClose(wLogSocket) == FALSE ) {
		ErrorMessage(GP02_SOCKET_AUTO);
		return 1;
	}
	wsprintf(szbuf, _T("foCX̎gpI\n\n")
					_T("LogSocket: %2d") ,
					wLogSocket);
	ResultMessage(szbuf);
	//---------------------------------------------------------------------------
	// DLL̃A[h
	//---------------------------------------------------------------------------
  	Gp02wDllClose();
	return 0;
}
//---------------------------------------------------------------------------
// ʂ\
//---------------------------------------------------------------------------
static void	ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, "AXP-GP02", MB_OK | MB_ICONINFORMATION);
}
//---------------------------------------------------------------------------
// G[bZ[W\ďI
//---------------------------------------------------------------------------
static void	ErrorMessage(WORD wLogSocket)
{
	DWORD 	dwRes = Gp02wGetLastError(wLogSocket);
	TCHAR	szbuf[50];

	switch(dwRes) {
		case GP02_ERR_SYSTEM:
			wsprintf(szbuf, _T("System error\n\n")
							_T("Error code: %08lxH") , GetLastError());
			break;

		case GP02_ERR_WRAPDLL:
			wsprintf(szbuf, _T("DLL Load error"));
			break;

		default:
			wsprintf(szbuf, _T("AXP-GP02 error\n\n")
							_T("Error code: %08lxH") , dwRes);
			break;
	}
	MessageBox(NULL, szbuf, "AXP-GP02", MB_OK | MB_ICONSTOP);
	// I
	Gp02wClose(wLogSocket);
  	Gp02wDllClose();
}

