//============================================================================
//	Axpgp02w.cs
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//============================================================================
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Runtime.InteropServices;

namespace SampleGp02
{
	/// <summary>
	/// Axpgp02w ̊Tv̐łB
	/// </summary>
	public class Axpgp02w
	{
		private int mErrWradll = SUCCESS;		// bp[֐G[

		//-------------------------------------------------------------------
		// G[R[h
		//-------------------------------------------------------------------
		public const int SUCCESS				= 0;	// ُȂiIj
		public const int ERR_SYSTEM				= 1;	// ɃhCo[hĂȂ\܂
		public const int ERR_NO_DEVICE			= 2;	// gp\ȃfoCX܂
		public const int ERR_IN_USE				= 3;	// w̃foCX͑̃vZXŎgpł
		public const int ERR_INVALID_SOCKET		= 4;	// Ș_\Pbgԍł
		public const int ERR_RESOURCE			= 5;	// \[XG[
		public const int ERR_INVALID_ARGUMENT	= 6;	// sȈw肵܂
		public const int ERR_NOTINIT			= 7;	// Ă܂B
		public const int ERR_MODE				= 8;	// GPIB ̃[hG[łB
		public const int ERR_TIMEOUT			= 9;	// ^CAEg܂B
		public const int ERR_NOLSN				= 10;	// XiiP[uڑj
		public const int ERR_BUSY				= 11;	// s
		public const int ERR_ETC				= 12;	// ̑̃G[
		public const int ERR_WRAPDLL			= -1;	// bp[֐G[

		//-------------------------------------------------------------------
		// GPIBXe[^X擾
		//-------------------------------------------------------------------
		public const int STS_IFC			= 0x1;		// IFC
		public const int STS_DCAS			= 0x2;		// DeviceClear
		public const int STS_UNC			= 0x4;		// Ppoll,TCT etc
		public const int STS_ERR			= 0x8;		// Error
		public const int STS_GET			= 0x10;		// GET
		public const int STS_SPAS			= 0x20;		// Spoll
		public const int STS_END			= 0x40;		// END
		public const int STS_REM			= 0x100;	// Remote
		public const int STS_LLO			= 0x200;	// LLO
		public const int STS_TLK			= 0x400;	// Talker
		public const int STS_LSN			= 0x800;	// Listener
		public const int STS_ATN			= 0x1000;	// ATN
		public const int STS_SRQ			= 0x2000;	// SRQ
		public const int STS_REN			= 0x4000;	// REN
		//------------------------------------------------------------------
		// GPIB֘Ap[^w͈
		//-------------------------------------------------------------------
		public const short ADDR_MIN			= 0;		// ŏGPIBڽ
		public const short ADDR_MAX			= 30;		// ő    "
		public const int TIMEOUT_DEFAULT	= 2000;		// ѱ̫
		public const int TIMEOUT_MAX		= 60000;	// ѱčől
		//-------------------------------------------------------------------
		// }`CbZ[W(GPIBR}h)w
		//-------------------------------------------------------------------
		public const byte MLM_LA_0			= 0x20;		// Listener Addr
		public const byte MLM_TA_0			= 0x40;		// Talker Addr
		public const byte MLM_UNL			= 0x3F;		// UNListen
		public const byte MLM_UNT			= 0x5F;		// UNTalk
		public const byte MLM_GTL			= 0x1;		// Go To Local
		public const byte MLM_SDC			= 0x4;		// Select Device Clear
		public const byte MLM_GETRG			= 0x8;		// Group Execute Trigger
		public const byte MLM_LLO			= 0x11;		// Local Lock Out
		public const byte MLM_DCL			= 0x14;		// Device Clear
		public const byte MLM_SPE			= 0x18;		// Serial Poll Enable
		public const byte MLM_SPD			= 0x19;		// Serial Poll Disable
		public const byte MLM_PPC			= 0x5;		// Parallel Poll Config
		public const byte MLM_PPE			= 0x60;		// Parallel Poll Enable
		public const byte MLM_PPZ			= 0x70;		// Parallel Poll Disable
		public const byte MLM_PPU			= 0x15;		// Parallel Poll Unconfig
		public const byte MLM_TCT			= 0x9;		// Take Control (XXX)
		//-------------------------------------------------------------------
		// GPIB샂[hw
		//-------------------------------------------------------------------
		public const short MODE_SYSCON		= 1;		// Ѻ۰Ӱ
		public const short MODE_TLKLSN		= 0;		// İؽӰ
		public const short MODE_SLAVE		= 0;		// ڰӰ
		public const short MODE_CON			= 2;		// ۰Ӱ(gps)
		public const short MODE_MASTER		= 2;		// ϽӰ(gps)
		//-------------------------------------------------------------------
		// f~^[hw
		//-------------------------------------------------------------------
		public const short DELIM_CRLF		= 1;		// CR + LF(̫)
		public const short DELIM_CR			= 2;		// CR
		public const short DELIM_LF			= 3;		// LF
		public const short DELIM_NO			= 0;		// NOTHING
		//-------------------------------------------------------------------
		// dnh[hw
		//-------------------------------------------------------------------
		public const short EOI_ON			= 1;		// t(̫)
		public const short EOI_OFF			= 0;		// Ȃ
		//-------------------------------------------------------------------
		// ̑̒萔
		//-------------------------------------------------------------------
		public const short SOCKET_AUTO		= -1;
		public const int MAX_SOCKETS		= 16;		// foCX͂PU܂Ŏg܂
		//-------------------------------------------------------------------
		// \[X\̊evf̍ő吔
		//-------------------------------------------------------------------
		public const int MAX_MEM			= 9;
		public const int MAX_IO				= 20;
		public const int MAX_IRQ			= 7;
		public const int MAX_DMA			= 7;
		public const int MAX_RSV			= 3;

		[StructLayout(LayoutKind.Sequential)]
			public struct Resource
		{
			public int		dwNumMemWindows;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_MEM)]
			public int[]	dwMemBase;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_MEM)]
			public int[]	dwMemLength;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_MEM)]
			public int[]	dwMemAttrib;
			public int		dwNumIOPorts;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IO)]
			public int[]	dwIOPortBase;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IO)]
			public int[]	dwIOPortLength;
			public int		dwNumIRQs;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IRQ)]
			public int[]	dwIRQRegisters;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IRQ)]
			public int[]	dwIRQAttrib;
			public int		dwNumDMAs;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_DMA)]
			public int[]	dwDMALst;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_DMA)]
			public int[]	dwDMAAttrib;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_RSV)]
			public int[]	dwReserved1;
		}
	
		//-------------------------------------------------------------------
		// API Functions
		//-------------------------------------------------------------------
		[DllImport("axpgp02.dll")]
		public extern static        int  Gp02GetLastError( short wLogSocket );
		[DllImport("axpgp02.dll")]
		public extern static        int  Gp02GetStatus( short wLogSocket );
		[DllImport("axpgp02.dll")]
		public extern static unsafe bool Gp02GetVersion( int* pdwDllVersion, int* pdwDriverVersion );
		[DllImport("axpgp02.dll")]
		public extern static unsafe bool Gp02Create( short* pwLogSocket );
		[DllImport("axpgp02.dll")]
		public extern static        bool Gp02Close( short wLogSocket );
		[DllImport("axpgp02.dll")]
		public extern static unsafe bool Gp02GetResource( short wLogSocket, ref Resource pResInfo );
		[DllImport("axpgp02.dll")]
		public extern static        bool Gp02Init( short wLogSocket, short wGpibAddr, short wGpibMode, int dwFifoSize );
		[DllImport("axpgp02.dll")]
		public extern static        bool Gp02SetTime( short wLogSocket, int dwTimeoutCnt );
		[DllImport("axpgp02.dll")]
		public extern static        bool Gp02SetEos( short wLogSocket, short wDlmMode, short wEoiMode );
		[DllImport("axpgp02.dll")]
		public extern static unsafe bool Gp02SendCmd( short wLogSocket, byte* pSendBuf, int dwSendBytes);
		[DllImport("axpgp02.dll")]
		public extern static        bool Gp02Ifc( short wLogSocket );
		[DllImport("axpgp02.dll")]
		public extern static        bool Gp02Ren( short wLogSocket, short wRenLine );
		[DllImport("axpgp02.dll")]
		public extern static        bool Gp02Dcl( short wLogSocket );
		[DllImport("axpgp02.dll")]
		public extern static        bool Gp02Sdc( short wLogSocket, short wLsnAdrs );
		[DllImport("axpgp02.dll")]
		public extern static unsafe bool Gp02SendDataCN( short wLogSocket, short* pwLsnAdrsList, short wLsnAdrsCnt, byte* pbSendBuff, int dwDataCnt );
		[DllImport("axpgp02.dll")]
		public extern static unsafe bool Gp02SendDataC( short wLogSocket, short wLsnAdrs, byte* pbSendBuff, int dwDataCnt );
		[DllImport("axpgp02.dll")]
		public extern static unsafe bool Gp02SendDataS( short wLogSocket, byte* pbSendBuff, int dwDataCnt );
		[DllImport("axpgp02.dll")]
		public extern static unsafe bool Gp02RecvDataC( short wLogSocket, short wTlkAdrs, byte* pbRecvBuff, int* pdwDataCnt );
		[DllImport("axpgp02.dll")]
		public extern static unsafe bool Gp02RecvDataS( short wLogSocket, byte* pbRecvBuff, int* pdwDataCnt );
		[DllImport("axpgp02.dll")]
		public extern static unsafe bool Gp02TransDataN( short wLogSocket, short wTlkAdrs, short* pwLsnAdrsList, short wLsnAdrsCnt );
		[DllImport("axpgp02.dll")]
		public extern static        bool Gp02TransData( short wLogSocket, short wTlkAdrs, short wLsnAdrs );
		[DllImport("axpgp02.dll")]
		public extern static        bool Gp02SetSrqLine( short wLogSocket, byte bStsByte );
		[DllImport("axpgp02.dll")]
		public extern static unsafe bool Gp02GetSrqLine( short wLogSocket, short* pwSrqLine );
		[DllImport("axpgp02.dll")]
		public extern static unsafe bool Gp02Spoll( short wLogSocket, short wPollAdrs, byte* pbStsByte );
		[DllImport("axpgp02.dll")]
		public extern static unsafe bool Gp02Ppoll( short wLogSocket, byte* pbDioLine );
		[DllImport("axpgp02.dll")]
		public extern static        bool Gp02PpollConfig( short wLogSocket, short wLsnAdrs, byte bDioLine, byte bSbit );
		[DllImport("axpgp02.dll")]
		public extern static        bool Gp02PpollUnConfig( short wLogSocket, short wLsnAdrs );
		[DllImport("axpgp02.dll")]
		public extern static        bool Gp02PpollUnConfigAll( short wLogSocket );
		[DllImport("axpgp02.dll")]
		public extern static        bool Gp02PpollRespModeSet( short wLogSocket, short wPMode );

		//===================================================================
		//   		G[R[h擾
		//   		wLogSocket		foCX
		// ߂l		G[R[h
		//===================================================================
		public int GetLastError( short wLogSocket )
		{
			try {
				if (mErrWradll == ERR_WRAPDLL) {	// bp[֐G[Ȃ
					mErrWradll = SUCCESS;			// NA
					return ERR_WRAPDLL;
				} else {
					return Gp02GetLastError(wLogSocket);
				}
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-GP02 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = SUCCESS;	// bp[֐G[
				return ERR_WRAPDLL;
			}
		}
		//===================================================================
		//   		GPIBXe[^X̎擾
		//   		wLogSocket		foCX
		// ߂l		Xe[^X
		//===================================================================
		public int GetStatus( short wLogSocket )
		{
			try
			{
				return Gp02GetStatus(wLogSocket);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "AXP-GP02 Error", 
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return ERR_WRAPDLL;
			}
		}
		//============================================================================
		// 		DLL,޲ײްްޮݔԍ擾
		// 		pdwDllVersion		DLLްޮݔԍi[̈ւ߲
		//			pdwDriverVersion	޲ײްްޮݔԍi[̈ւ߲
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public unsafe bool GetVersion( int* pdwDllVersion, int* pdwDriverVersion )
		{
			try
			{
				return Gp02GetVersion(pdwDllVersion, pdwDriverVersion);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "AXP-GP02 Error", 
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		޲̎gp錾
		// 		pwLogSocket		gp޲̘_Ĕԍi[߲
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public unsafe bool Create( short* pwLogSocket )
		{
			try
			{
				return Gp02Create(pwLogSocket);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "AXP-GP02 Error", 
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		޲J
		// 		wLogSocket		޲̘_Ĕԍ
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public bool Close( short wLogSocket )
		{
			try
			{
				return Gp02Close(wLogSocket);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "AXP-GP02 Error", 
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		w޲ؿ擾
		// 		wLogSocket		޲̘_Ĕԍ
		//			pResInfo		ؿi[\߲̂
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public unsafe bool GetResource( short wLogSocket, ref Resource pResInfo )
		{
			try
			{
				return Gp02GetResource(wLogSocket, ref pResInfo);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "AXP-GP02 Error", 
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		
		// 		wLogSocket		޲̘_Ĕԍ
		//			wGpibAddr   	g GP-IB AhX
		//			wGpibMode		g GP-IB 샂[h
		//			dwFifoSize		Mobt@̑傫
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public bool Init( short wLogSocket, short wGpibAddr, short wGpibMode, int dwFifoSize )
		{
			try
			{
				return Gp02Init(wLogSocket, wGpibAddr, wGpibMode, dwFifoSize);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "AXP-GP02 Error", 
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		GPIBѱĐݒ
		// 		wLogSocket		޲̘_Ĕԍ
		//			dwTimeoutCnt  	^CAEglBPʂ̓~b0`60000܂ŁB
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public bool SetTime( short wLogSocket, int dwTimeoutCnt )
		{
			try
			{
				return Gp02SetTime(wLogSocket, dwTimeoutCnt);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "AXP-GP02 Error", 
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		EOIݒ
		// 		wLogSocket		޲̘_Ĕԍ
		//			wDlmMode    	f~^w
		//			wEoiMode    	dnh̎gp܂͕sgpw
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public bool SetEos( short wLogSocket, short wDlmMode, short wEoiMode )
		{
			try
			{
				return Gp02SetEos(wLogSocket, wDlmMode, wEoiMode);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "AXP-GP02 Error", 
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		GPIBޑM(۰חp)
		// 		wLogSocket		޲̘_Ĕԍ
		//			paSendBuf   	MR}hobt@̃AhX
		//			dwSendBytes		MׂR}h̃oCg
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public unsafe bool SendCmd( short wLogSocket, byte* paSendBuf, int dwSendBytes )
		{
			try
			{
				return Gp02SendCmd(wLogSocket, paSendBuf, dwSendBytes);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "AXP-GP02 Error", 
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		IFCM(۰חp)
		// 		wLogSocket		޲̘_Ĕԍ
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public bool Ifc( short wLogSocket )
		{
			try
			{
				return Gp02Ifc(wLogSocket);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "AXP-GP02 Error", 
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		RENײ݂̐ݒ(۰חp)
		// 		wLogSocket		޲̘_Ĕԍ
		//			wRenLine		1(^)/0(U)
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public bool Ren( short wLogSocket, short wRenLine )
		{
			try
			{
				return Gp02Ren(wLogSocket, wRenLine);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "AXP-GP02 Error", 
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		DCLM(۰חp)
		// 		wLogSocket		޲̘_Ĕԍ
		// ߂l	 	true
		//			s 	false
		//============================================================================
		public bool Dcl( short wLogSocket )
		{
			try
			{
				return Gp02Dcl(wLogSocket);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "AXP-GP02 Error", 
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		w@ւSDCM(۰חp)
		// 		wLogSocket		޲̘_Ĕԍ
		//			wLsnAdrs		XiAhX
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public bool Sdc( short wLogSocket, short wLsnAdrs )
		{
			try
			{
				return Gp02Sdc(wLogSocket, wLsnAdrs);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "AXP-GP02 Error", 
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		̎w@ւްM(۰חp)
		// 		wLogSocket		޲̘_Ĕԍ
		//			pwLsnAdrsList 	XiAhXXg̃AhX
		//			wLsnAdrsCnt		XiAhX̐
		//			pbSendBuff		Mf[^obt@̃AhX
		//			dwDataCnt		Mf[^
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public unsafe bool SendDataCN( short wLogSocket, short* pwLsnAdrsList, short wLsnAdrsCnt, byte* pbSendBuff, int dwDataCnt )
		{
			try
			{
				return Gp02SendDataCN(wLogSocket, pwLsnAdrsList, wLsnAdrsCnt, pbSendBuff, dwDataCnt);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "AXP-GP02 Error", 
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		w@ւްM(۰חp)
		// 		wLogSocket		޲̘_Ĕԍ
		//			wLsnAdrs		XiAhX
		//			pbSendBuff		Mf[^obt@̃AhX
		//			dwDataCnt   	Mf[^
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public unsafe bool SendDataC( short wLogSocket, short wLsnAdrs, byte* pbSendBuff, int dwDataCnt )
		{
			try
			{
				return Gp02SendDataC(wLogSocket, wLsnAdrs, pbSendBuff, dwDataCnt);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "AXP-GP02 Error", 
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		ްM(ڰޗp)
		// 		wLogSocket		޲̘_Ĕԍ
		//			pbSendBuff		Mf[^obt@̃AhX
		//			dwDataCnt		Mf[^
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public unsafe bool SendDataS( short wLogSocket, byte* pbSendBuff, int dwDataCnt )
		{
			try
			{
				return Gp02SendDataS(wLogSocket, pbSendBuff, dwDataCnt);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "AXP-GP02 Error", 
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		w@킩ްM(۰חp)
		// 		wLogSocket		޲̘_Ĕԍ
		//			wTlkAdrs		g[JAhX
		//			pbRecvBuff		Mf[^obt@̃AhX
		//			pdwDataCnt		Mf[^w肷ϐ̃AhX
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public unsafe bool RecvDataC( short wLogSocket, short wTlkAdrs, byte* pbRecvBuff, int* pdwDataCnt )
		{
			try
			{
				return Gp02RecvDataC(wLogSocket, wTlkAdrs, pbRecvBuff, pdwDataCnt);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "AXP-GP02 Error", 
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		ްM(ڰޗp)
		// 		wLogSocket		޲̘_Ĕԍ
		//			pbRecvBuff 		Mf[^obt@̃AhX
		//			pdwDataCnt  	Mf[^w肷ϐ̃AhX
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public unsafe bool RecvDataS( short wLogSocket, byte* pbRecvBuff, int* pdwDataCnt )
		{
			try
			{
				return Gp02RecvDataS(wLogSocket, pbRecvBuff, pdwDataCnt);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "AXP-GP02 Error", 
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		@ް](۰חp)
		// 		wLogSocket		޲̘_Ĕԍ
		//			wTlkAdrs      	g[JAhX
		//			pwLsnAdrsList	XiAhXXg̃AhX
		//			wLsnAdrsCnt		XiAhX̐
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public unsafe bool TransDataN( short wLogSocket, short wTlkAdrs, short* pwLsnAdrsList, short wLsnAdrsCnt )
		{
			try
			{
				return Gp02TransDataN(wLogSocket, wTlkAdrs, pwLsnAdrsList, wLsnAdrsCnt);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "AXP-GP02 Error", 
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		@ް](۰חp)
		// 		wLogSocket		޲̘_Ĕԍ
		//			wTlkAdrs		g[JAhX
		//			wLsnAdrs		XiAhX
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public bool TransData( short wLogSocket, short wTlkAdrs, short wLsnAdrs )
		{
			try
			{
				return Gp02TransData(wLogSocket, wTlkAdrs, wLsnAdrs);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "AXP-GP02 Error", 
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		SRQײ݂ƽð޲Đݒ(ڰޗp)
		// 		wLogSocket		޲̘_Ĕԍ
		//			bStsByte		Xe[^XoCgl
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public bool SetSrqLine( short wLogSocket, byte bStsByte )
		{
			try
			{
				return Gp02SetSrqLine(wLogSocket, bStsByte);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "AXP-GP02 Error", 
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		SRQײ݂̏Ԕ(۰חp)
		// 		wLogSocket		޲̘_Ĕԍ
		//			pwSrqLine		rqpCԂi[ϐ̃AhX
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public unsafe bool GetSrqLine( short wLogSocket, short* pwSrqLine )
		{
			try
			{
				return Gp02GetSrqLine(wLogSocket, pwSrqLine);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "AXP-GP02 Error", 
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		رَ߰s(۰חp)
		// 		wLogSocket		޲̘_Ĕԍ
		//			wPollAdrs		|[ÕAhX
		//			pbStsByte		Xe[^XoCgi[ϐ̃AhX
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public unsafe bool Spoll( short wLogSocket, short wPollAdrs, byte* pbStsByte )
		{
			try
			{
				return Gp02Spoll(wLogSocket, wPollAdrs, pbStsByte);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "AXP-GP02 Error", 
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		َ߰s(۰חp)
		// 		wLogSocket		޲̘_Ĕԍ
		//			pbDioLine   	chnCi[ϐ̃AhX
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public unsafe bool Ppoll( short wLogSocket, byte* pbDioLine )
		{
			try
			{
				return Gp02Ppoll(wLogSocket, pbDioLine);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "AXP-GP02 Error", 
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		ٍ߰\(۰חp)
		// 		wLogSocket		޲̘_Ĕԍ
		//			wLsnAdrs		\@AhX
		//			bDioLine    	@tDIOCԍiO`ṼrbgԍŎwj
		//			bSbit			ZXrbg̎wiO܂͂Pj
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public bool PpollConfig( short wLogSocket, short wLsnAdrs, byte bDioLine, byte bSbit )
		{
			try
			{
				return Gp02PpollConfig(wLogSocket, wLsnAdrs, bDioLine, bSbit);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "AXP-GP02 Error", 
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		w@ٍ߰\(۰חp)
		// 		wLogSocket		޲̘_Ĕԍ
		//			wLsnAdrs		\@AhX
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public bool PpollUnConfig( short wLogSocket, short wLsnAdrs )
		{
			try
			{
				return Gp02PpollUnConfig(wLogSocket, wLsnAdrs);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "AXP-GP02 Error", 
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		S@ٍ߰\(۰חp)
		// 		wLogSocket		޲̘_Ĕԍ
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public bool PpollUnConfigAll( short wLogSocket )
		{
			try
			{
				return Gp02PpollUnConfigAll(wLogSocket);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "AXP-GP02 Error", 
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		߰ىݒ(ڰޗp)
		// 		wLogSocket		޲̘_Ĕԍ
		//			wPMode			p|[ւ̉@
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public bool PpollRespModeSet( short wLogSocket, short wPMode )
		{
			try
			{
				return Gp02PpollRespModeSet(wLogSocket, wPMode);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "AXP-GP02 Error", 
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
	
	
	}
}
