'===================================================================
' Axpgp02s.vb
'-------------------------------------------------------------------
' AXP-GP02
' Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'
' ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂
'===================================================================

Option Strict Off
Option Explicit On 

Imports System.Runtime.InteropServices

Public Class Form1
    Inherits System.Windows.Forms.Form

    Dim Gp02w As Axpgp02w

    Private Const MAXBUFF = 4096                ' Mp̃obt@MAX
    Private Const MYADRS = 0                    ' GPIBAhX
    Private Const PRTADRS = 1                   ' GPIBAhX

#Region " Windows tH[ fUCiŐꂽR[h "

    Public Sub New()
        MyBase.New()

        ' ̌Ăяo Windows tH[ fUCiŕKvłB
        InitializeComponent()

        ' InitializeComponent() Ăяǒɏǉ܂B

    End Sub

    ' Form ́AR|[lgꗗɌ㏈s邽߂ dispose I[o[Ch܂B
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Windows tH[ fUCiŕKvłB
    Private components As System.ComponentModel.IContainer

    '  : ȉ̃vV[ẂAWindows tH[ fUCiŕKvłB
    'Windows tH[ fUCigĕύXĂB  
    ' R[h GfB^gĕύXȂłB
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 12)
        Me.ClientSize = New System.Drawing.Size(292, 266)
        Me.Name = "Form1"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "AXP-GP02 Sample"

    End Sub

#End Region

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim strbuf As String
        Dim dwDllVer As Integer, dwDrvVer As Integer    ' DLL, Drivero[W
        Dim bResult As Boolean                          ' 
        Dim wLogSocket As Short                         ' foCXi[
        Dim wGpibAdrs As Short                          ' haAhX
        Dim wGpibMode As Short                          ' ha[h
        Dim dwFifoSize As Integer                       ' haobt@TCY
        Dim dwTimeout As Integer                        ' ^CAEgl
        Dim ri As Axpgp02w.Resource                     '  \[X
        Dim SendBuff(MAXBUFF) As Byte                   ' Mp̃obt@
        Dim RecvBuff(MAXBUFF) As Byte                   ' Mp̃obt@
        Dim dwDataCnt As Integer                        ' Mf[^
        Dim wSrqLine As Short                           ' rqpC
        Dim bStsByte As Byte                            ' Xe[^XoCg
        Dim i As Integer                                ' [vpϐ

        ' 
        Gp02w = New Axpgp02w
        ri = New Axpgp02w.Resource
        ri.dwMemBase = New Integer(Axpgp02w.MAX_MEM) {}
        ri.dwMemLength = New Integer(Axpgp02w.MAX_MEM) {}
        ri.dwMemAttrib = New Integer(Axpgp02w.MAX_MEM) {}
        ri.dwIOPortBase = New Integer(Axpgp02w.MAX_IO) {}
        ri.dwIOPortLength = New Integer(Axpgp02w.MAX_IO) {}
        ri.dwIRQRegisters = New Integer(Axpgp02w.MAX_IRQ) {}
        ri.dwIRQAttrib = New Integer(Axpgp02w.MAX_IRQ) {}
        ri.dwDMALst = New Integer(Axpgp02w.MAX_DMA) {}
        ri.dwDMAAttrib = New Integer(Axpgp02w.MAX_DMA) {}
        ri.dwReserved1 = New Integer(Axpgp02w.MAX_RSV) {}

        ' 
        ri.dwNumMemWindows = 0
        For i = 0 To Axpgp02w.MAX_MEM
            ri.dwMemBase(i) = 0
            ri.dwMemLength(i) = 0
            ri.dwMemAttrib(i) = 0
        Next
        ri.dwNumIOPorts = 0
        For i = 0 To Axpgp02w.MAX_IO
            ri.dwIOPortBase(i) = 0
            ri.dwIOPortLength(i) = 0
        Next
        ri.dwNumIRQs = 0
        For i = 0 To Axpgp02w.MAX_IRQ
            ri.dwIRQRegisters(i) = 0
            ri.dwIRQAttrib(i) = 0
        Next
        ri.dwNumDMAs = 0
        For i = 0 To Axpgp02w.MAX_DMA
            ri.dwDMALst(i) = 0
            ri.dwDMAAttrib(i) = 0
        Next
        For i = 0 To Axpgp02w.MAX_RSV
            ri.dwReserved1(i) = 0
        Next

        '---------------------------------------------------------------
        ' DLL,DRṼo[Wԍ擾
        '---------------------------------------------------------------
        If Gp02w.GetVersion(dwDllVer, dwDrvVer) = False Then
            ErrorMessage(Axpgp02w.SOCKET_AUTO)
            Exit Sub
        End If
        strbuf = String.Concat("o[Wԍ擾", vbCrLf, _
                                String.Format("DLL Version: &H{0:x8}", dwDllVer), vbCrLf, _
                                String.Format("Drv Version: &H{0:x8}", dwDrvVer))
        ResultMessage(strbuf)

        '---------------------------------------------------------------
        ' foCX̎gp錾
        '---------------------------------------------------------------
        wLogSocket = Axpgp02w.SOCKET_AUTO  ' gp̃foCXT܂B
        bResult = Gp02w.Create(wLogSocket) ' ꍇA̎̃foCXi[܂B
        If bResult = False Then
            ErrorMessage(wLogSocket)
            Exit Sub
        End If
        strbuf = String.Concat("foCX̎gp錾", vbCrLf, vbCrLf, _
                                String.Format("LogSlot: {0}", wLogSocket))
        ResultMessage(strbuf)

        '---------------------------------------------------------------
        ' \[X擾
        '---------------------------------------------------------------
        If Gp02w.GetResource(wLogSocket, ri) = False Then
            ErrorMessage(wLogSocket)
            Exit Sub
        End If
        strbuf = String.Concat("\[X擾", vbCrLf, _
                                String.Format("NumPorts   : {0:x}", _
                                                ri.dwIOPortLength(0)), vbCrLf, _
                                String.Format("IO Address : &H{0:x4} - &H{1:x4}", _
                                                ri.dwIOPortBase(0), _
                                                ri.dwIOPortBase(0) + ri.dwIOPortLength(0) - 1), vbCrLf, _
                                String.Format("IRQ        : {0}", ri.dwIRQRegisters(0)))
        ResultMessage(strbuf)

        '---------------------------------------------------------------
        ' aPCI-G01̏
        '---------------------------------------------------------------
        wGpibAdrs = MYADRS                  ' ̂haAhX
        wGpibMode = Axpgp02w.MODE_SYSCON    ' Rg[ɂȂ
        dwFifoSize = MAXBUFF                ' FIFOobt@TCYw
        If Gp02w.Init(wLogSocket, wGpibAdrs, wGpibMode, dwFifoSize) = False Then
            ErrorMessage(wLogSocket)
            Exit Sub
        End If
        strbuf = String.Concat("AXP-GP02̏", vbCrLf, vbCrLf, _
                                String.Format("My IB-Address: {0}", wGpibAdrs), vbCrLf, _
                                String.Format("IB-Mode: {0}", wGpibMode), vbCrLf, _
                                String.Format("FifoSize: {0}", dwFifoSize))
        ResultMessage(strbuf)

        '---------------------------------------------------------------
        ' GP-IB ̃^CAEgݒ
        '---------------------------------------------------------------
        dwTimeout = 3000        ' ^CAEgl=Rb
        If Gp02w.SetTime(wLogSocket, dwTimeout) = False Then
            ErrorMessage(wLogSocket)
            Exit Sub
        End If
        strbuf = String.Concat("GP-IB̃^CAEgݒ", vbCrLf, vbCrLf, _
                                String.Format("Timeout: {0}msec", dwTimeout))
        ResultMessage(strbuf)

        '---------------------------------------------------------------
        ' f~^Ƃdnhݒ
        '---------------------------------------------------------------
        If Gp02w.SetEos(wLogSocket, Axpgp02w.DELIM_CRLF, Axpgp02w.EOI_ON) = False Then
            ErrorMessage(wLogSocket)
            Exit Sub
        End If
        strbuf = String.Concat("f~^EOIݒ", vbCrLf, vbCrLf, _
                                "f~^: CR+LF", vbCrLf, _
                                "EOI: On")
        ResultMessage(strbuf)

        '---------------------------------------------------------------
        ' heb̑MiRg[pj
        '---------------------------------------------------------------
        If Gp02w.Ifc(wLogSocket) = False Then
            ErrorMessage(wLogSocket)
            Exit Sub
        End If
        ResultMessage("heb̑M")

        '---------------------------------------------------------------
        ' w@ւ̃f[^MiRg[pj
        '---------------------------------------------------------------
        wGpibAdrs = PRTADRS         ' XîhaAhX
        strbuf = "0123456789"       ' Mf[^
        dwDataCnt = strbuf.Length   ' Mf[^
        SendBuff = System.Text.Encoding.GetEncoding(932).GetBytes(strbuf)
        If Gp02w.SendDataC(wLogSocket, wGpibAdrs, SendBuff, dwDataCnt) = False Then
            ErrorMessage(wLogSocket)
            Exit Sub
        End If
        ResultMessage("w@ւ̃f[^M")

        '---------------------------------------------------------------
        ' w@킩̃f[^MiRg[pj
        '---------------------------------------------------------------
        wGpibAdrs = PRTADRS             ' g[ĴhaAhX
        dwDataCnt = 50                  ' Mf[^
        If Gp02w.RecvDataC(wLogSocket, wGpibAdrs, RecvBuff, dwDataCnt) = False Then
            ErrorMessage(wLogSocket)
            Exit Sub
        End If
        RecvBuff(dwDataCnt) = 0
        strbuf = String.Concat("w@킩̃f[^M", vbCrLf, vbCrLf, _
                                String.Format("DataCnt: {0}", dwDataCnt), vbCrLf, _
                                "Data   : ", _
                                System.Text.Encoding.GetEncoding(932).GetString(RecvBuff))
        ResultMessage(strbuf)

        '---------------------------------------------------------------
        ' rqpC̏ԔiRg[pj
        '---------------------------------------------------------------
        If Gp02w.GetSrqLine(wLogSocket, wSrqLine) = False Then
            ErrorMessage(wLogSocket)
            Exit Sub
        End If
        strbuf = String.Concat("rqpC̏Ԕ", vbCrLf, vbCrLf, _
                                String.Format("SRQ line: {0}", wSrqLine))
        ResultMessage(strbuf)

        '---------------------------------------------------------------
        ' VA|[siRg[pj
        '---------------------------------------------------------------
        If wSrqLine = 1 Then
            wGpibAdrs = PRTADRS         ' VA|[haAhX
            If Gp02w.Spoll(wLogSocket, wGpibAdrs, bStsByte) = False Then
                ErrorMessage(wLogSocket)
                Exit Sub
            End If
            strbuf = String.Concat("VA|[s", vbCrLf, vbCrLf, _
                                    String.Format("STS Byte: &H{0:x2}", bStsByte))
            ResultMessage(strbuf)
        End If

        '---------------------------------------------------------------
        ' foCX̎gpI
        '---------------------------------------------------------------
        If Gp02w.Close(wLogSocket) = False Then
            ErrorMessage(wLogSocket)
            Exit Sub
        End If
        strbuf = String.Concat("foCX̎gpI", vbCrLf, vbCrLf, _
                                String.Format("LogSlot: {0}", wLogSocket))
        ResultMessage(strbuf)

        Me.Close
    End Sub

    '===================================================================
    ' ʂ\
    '===================================================================
    Private Sub ResultMessage(ByVal lpszbuf As String)

        MsgBox(lpszbuf, vbOKOnly + vbInformation, Me.Text)

    End Sub
    '===================================================================
    ' G[bZ[W\
    '===================================================================
    Private Sub ErrorMessage(ByVal wLogSocket As Integer)
        Dim dwRes As Long
        Dim szbuf As String

        dwRes = Gp02w.GetLastError(wLogSocket)
        Select Case dwRes
            Case Axpgp02w.ERR_WRAPDLL, Axpgp02w.ERR_SYSTEM
                dwRes = System.Runtime.InteropServices.Marshal.GetLastWin32Error()
                szbuf = String.Concat("System error", vbCrLf, vbCrLf, _
                                        String.Format("Error code: {0:X8}H", dwRes))
            Case Else                           ' ̑̒l̏ꍇB
                szbuf = String.Concat("AXP-GP02 error", vbCrLf, vbCrLf, _
                                        String.Format("Error code: &H{0:x8}", dwRes))
        End Select
        MsgBox(szbuf, vbOKOnly + vbCritical, Me.Text)

    End Sub

End Class
