//===================================================================
// Axpgp02s.h
//-------------------------------------------------------------------
// AXP-GP02
// Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
// ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂
//==================================================================

#pragma once

#include "Axpgp02w.h"

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;


namespace SampleGp02
{
	/// <summary> 
	/// Axpgp02s ̊Tv
	///
	/// x : ̃NX̖OύXꍇÃNXˑ邷ׂĂ .resx t@CɊ֘Atꂽ 
	///          }l[W \[X RpC c[ɑ΂ 'Resource File Name' vpeB 
	///          ύXKv܂B̕ύXsȂƁA
	///          fUCiƁÃtH[Ɋ֘Atꂽ[JCYς݃\[XƂA
	///          ݂ɗpłȂȂ܂B
	/// </summary>
	public __gc class Axpgp02s : public System::Windows::Forms::Form
	{
	public: 
		Axpgp02s(void)
		{
			InitializeComponent();
		}
        
	protected: 
		void Dispose(Boolean disposing)
		{
			if (disposing && components)
			{
				components->Dispose();
			}
			__super::Dispose(disposing);
		}
        
	private:
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		System::ComponentModel::Container* components;

		static Axpgp02w* Gp02w;

		static const int   MAXBUFF = 4096;	// Mp̃obt@MAX
		static const short MYADRS = 0;		// GPIBAhX
		static const short PRTADRS = 1;		// GPIBAhX

		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
			// 
			// Axpgp02s
			// 
			this->AutoScaleBaseSize = System::Drawing::Size(5, 12);
			this->ClientSize = System::Drawing::Size(292, 266);
			this->Name = S"Axpgp02s";
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = S"AXP-GP02 Sample";
			this->Load += new System::EventHandler(this, Axpgp02s_Load);

		}		
		private: System::Void Axpgp02s_Load(System::Object *  sender, System::EventArgs *  e)
		{
			String* szbuf;
			int		dwDllVer, dwDrvVer;	// DLL, Drivero[W
			bool	bResult;			// 
			short	wLogSocket;			// foCXi[
			short	wGpibAdrs;			// haAhX
			short	wGpibMode;			// ha[h
			int		dwFifoSize;			// haobt@TCY
			int		dwTimeout;			// ^CAEgl
			Axpgp02w::Resource*  ri;		// \[X
			char	RecvBuff[MAXBUFF];	// Mp̃obt@
			int		dwDataCnt;			// Mf[^
			short	wSrqLine;			// rqpC
			char	bStsByte;			// Xe[^XoCg
			short	i;					// [vpϐ

			// 
			Gp02w = new Axpgp02w();
			ri    = new Axpgp02w::Resource();
			ri->dwMemBase		= new Int32 [Axpgp02w::MAX_MEM];
			ri->dwMemLength		= new Int32 [Axpgp02w::MAX_MEM];
			ri->dwMemAttrib		= new Int32 [Axpgp02w::MAX_MEM];
			ri->dwIOPortBase	= new Int32 [Axpgp02w::MAX_IO];
			ri->dwIOPortLength	= new Int32 [Axpgp02w::MAX_IO];
			ri->dwIRQRegisters	= new Int32 [Axpgp02w::MAX_IRQ];
			ri->dwIRQAttrib		= new Int32 [Axpgp02w::MAX_IRQ];
			ri->dwDMALst		= new Int32 [Axpgp02w::MAX_DMA];
			ri->dwDMAAttrib		= new Int32 [Axpgp02w::MAX_DMA];
			ri->dwReserved1		= new Int32 [Axpgp02w::MAX_RSV];

			// 
			ri->dwNumMemWindows = 0;
			for (i=0; i<Axpgp02w::MAX_MEM; i++) {
				ri->dwMemBase[i]   = 0;
				ri->dwMemLength[i] = 0;
				ri->dwMemAttrib[i] = 0;
			}
			ri->dwNumIOPorts = 0;
			for (i=0; i<Axpgp02w::MAX_IO; i++) {
				ri->dwIOPortBase[i]   = 0;
				ri->dwIOPortLength[i] = 0;
			}
			ri->dwNumIRQs = 0;
			for (i=0; i<Axpgp02w::MAX_IRQ; i++) {
				ri->dwIRQRegisters[i] = 0;
				ri->dwIRQAttrib[i]    = 0;
			}
			ri->dwNumDMAs = 0;
			for (i=0; i<Axpgp02w::MAX_DMA; i++) {
				ri->dwDMALst[i]    = 0;
				ri->dwDMAAttrib[i] = 0;
			}
			for (i=0; i<Axpgp02w::MAX_RSV; i++)
				ri->dwReserved1[i] = 0;

			//---------------------------------------------------------------
			// DLL,DRṼo[Wԍ擾
			//---------------------------------------------------------------
			if ( Gp02w->GetVersion(&dwDllVer, &dwDrvVer) == false ) {
				ErrorMessage(Axpgp02w::SOCKET_AUTO);
				return;
			}
			szbuf = String::Concat("o[Wԍ擾\n",
									String::Format("DLL Version: {0}h\n", 
													dwDllVer.ToString("x8")), 
									String::Format("Drv Version: {0}h",
													dwDrvVer.ToString("x8")));
			ResultMessage(szbuf);

			//---------------------------------------------------------------
			// foCX̎gp錾
			//---------------------------------------------------------------
			wLogSocket =Axpgp02w::SOCKET_AUTO;		// gp̃foCXT܂B
			bResult = Gp02w->Create(&wLogSocket);	// ꍇA̎̃foCXi[܂B
			if ( bResult == false ) {
				ErrorMessage(Axpgp02w::SOCKET_AUTO);
				return;
			}
			szbuf = String::Concat("foCX̎gp錾\n\n",
										String::Format("LogSlot: {0}",
														wLogSocket.ToString()));
			ResultMessage(szbuf);

			//---------------------------------------------------------------
			// \[X擾
			//---------------------------------------------------------------
			if ( Gp02w->GetResource(wLogSocket, ri) == false ) {
				ErrorMessage(wLogSocket);
				return;
			}
			szbuf = String::Concat("\[X擾\n",
									String::Format("NumPorts   : {0}h\n",
													ri->dwIOPortLength[0].ToString("x")),
									String::Format("IO Address : {0}h - {1}h\n",
													ri->dwIOPortBase[0].ToString("x4"), 
													(ri->dwIOPortBase[0] + ri->dwIOPortLength[0] - 1).ToString("x4")), 
									String::Format("IRQ        : {0}", 
													ri->dwIRQRegisters[0].ToString()));
			ResultMessage(szbuf);

			//---------------------------------------------------------------
			// aPCI-G01̏
			//---------------------------------------------------------------
			wGpibAdrs  = MYADRS;				// ̂haAhX
			wGpibMode  = Axpgp02w::MODE_SYSCON;	// Rg[ɂȂ
			dwFifoSize = MAXBUFF;				// FIFOobt@TCYw
			if ( Gp02w->Init(wLogSocket,wGpibAdrs,wGpibMode,dwFifoSize) == false ) {
				ErrorMessage(wLogSocket);
				return;
			}
			szbuf = String::Concat("AXP-GP02̏\n\n", 
									String::Format("My IB-Address: {0}\n", wGpibAdrs.ToString()), 
									String::Format("IB-Mode: {0}\n", wGpibMode.ToString()),
									String::Format("FifoSize: {0}", dwFifoSize.ToString()));
			ResultMessage(szbuf);

			//---------------------------------------------------------------
			// GP-IB ̃^CAEgݒ
			//---------------------------------------------------------------
			dwTimeout = 3000;	// ^CAEgl=Rb
			if ( Gp02w->SetTime(wLogSocket,dwTimeout) == false ) {
				ErrorMessage(wLogSocket);
				return;
			}
			szbuf = String::Concat("GP-IB̃^CAEgݒ\n\n", 
									String::Format("Timeout: {0}msec", dwTimeout.ToString()));
			ResultMessage(szbuf);

			//---------------------------------------------------------------
			// f~^Ƃdnhݒ
			//---------------------------------------------------------------
			if ( Gp02w->SetEos(wLogSocket,Axpgp02w::DELIM_CRLF,Axpgp02w::EOI_ON) == false) {
				ErrorMessage(wLogSocket);
				return;
			}
			szbuf = String::Concat("f~^EOIݒ\n\n", 
									"f~^: CR+LF\n", 
									"EOI: On");
			ResultMessage(szbuf);

			//---------------------------------------------------------------
			// heb̑MiRg[pj
			//---------------------------------------------------------------
			if ( Gp02w->Ifc(wLogSocket) == false ) {
				ErrorMessage(wLogSocket);
				return;
			}
			ResultMessage("heb̑M");

			//---------------------------------------------------------------
			// w@ւ̃f[^MiRg[pj
			//---------------------------------------------------------------
			wGpibAdrs = PRTADRS;		// XîhaAhX
			szbuf     = "0123456789";	// Mf[^
			dwDataCnt = szbuf->Length;	// Mf[^
			char* SendBuff = (char*)(void*)Marshal::StringToHGlobalAnsi(szbuf);
			if ( Gp02w->SendDataC(wLogSocket,wGpibAdrs,SendBuff,dwDataCnt) == false ) {
				Marshal::FreeHGlobal(SendBuff);
				ErrorMessage(wLogSocket);
				return;
			}
			Marshal::FreeHGlobal(SendBuff);
			ResultMessage("w@ւ̃f[^M");

			//---------------------------------------------------------------
			// w@킩̃f[^MiRg[pj
			//---------------------------------------------------------------
			wGpibAdrs = PRTADRS;		// g[ĴhaAhX
			dwDataCnt = 50;				// Mf[^
			if ( Gp02w->RecvDataC(wLogSocket,wGpibAdrs,RecvBuff,&dwDataCnt) == false ) {
				ErrorMessage(wLogSocket);
				return;
			}
			RecvBuff[dwDataCnt] = 0;
			szbuf = String::Concat("w@킩̃f[^M\n\n", 
									String::Format("DataCnt: {0}\n", dwDataCnt.ToString()), 
									"Data   : ", (String*)RecvBuff);
			ResultMessage(szbuf);

			//---------------------------------------------------------------
			// rqpC̏ԔiRg[pj
			//---------------------------------------------------------------
			if ( Gp02w->GetSrqLine(wLogSocket,&wSrqLine) == false ) {
				ErrorMessage(wLogSocket);
				return;
			}
			szbuf = String::Concat("rqpC̏Ԕ\n\n", 
									String::Format("SRQ line: {0}", wSrqLine.ToString()));
			ResultMessage(szbuf);

			//---------------------------------------------------------------
			// VA|[siRg[pj
			//---------------------------------------------------------------
			if ( wSrqLine == 1 ) {
				wGpibAdrs = PRTADRS;				// VA|[haAhX
				if ( Gp02w->Spoll(wLogSocket,wGpibAdrs,&bStsByte) == false ) {
					ErrorMessage(wLogSocket);
					return;
				}
				szbuf = String::Concat("VA|[s\n\n", 
										String::Format("STS Byte: {0}h", bStsByte.ToString("x2")));
				ResultMessage(szbuf);
			}

			//---------------------------------------------------------------
			// foCX̎gpI
			//---------------------------------------------------------------
			if ( Gp02w->Close(wLogSocket) == false ) {
				ErrorMessage(wLogSocket);
				return;
			}
			szbuf = String::Concat("foCX̎gpI\n\n", 
									String::Format("LogSlot: {0}", wLogSocket.ToString()));
			ResultMessage(szbuf);
			this->Close();
		}

		//============================================================================
		// ʂ\
		//============================================================================
		private: void ResultMessage(String* buf)
		{
			MessageBox::Show(buf, this->Text,
								MessageBoxButtons::OK, MessageBoxIcon::Information);
		}

		//============================================================================
		// װүނ\
		//============================================================================
		private: void ErrorMessage(short wLogSocket)
		{
			int dwRes = Gp02w->GetLastError(wLogSocket);
			String* buf;

			switch (dwRes) {
				case Axpgp02w::ERR_WRAPDLL:
				case Axpgp02w::ERR_SYSTEM:
					dwRes = System::Runtime::InteropServices::Marshal::GetLastWin32Error();
					buf = String::Concat("System error\n\n",
											String::Format("Error code: {0}h", 
															dwRes.ToString("x8")));
					break;
				default:
					buf = String::Concat("AXP-GP02 error\n\n",
											String::Format("Error code: {0}h", 
															dwRes.ToString("x8")));
					break;
			}
			MessageBox::Show(buf, this->Text,
								MessageBoxButtons::OK, MessageBoxIcon::Stop);
		}

	};
}
