//=========================================================================
// Axpgp02s.cs
//-------------------------------------------------------------------------
// AXP-GP02
// Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
// ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂
//=========================================================================

/*============================================================================
// rh IvV̐ݒ菇܂B
//
// 1.vWFNg [vpeB] y[WJ܂B
// 2.[rh] vpeB y[WNbN܂B
// 3.[AZ[t R[h̋] `FbN {bNXIɂ܂B
//==========================================================================*/

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace SampleGp02
{
    public partial class Axpgp02s : Form
    {
        static Axpgp02w Gp02w;

        const int MAXBUFF = 4096;		// Mp̃obt@MAX
        const short MYADRS = 0;			// GPIBAhX
        const short PRTADRS = 1;		// GPIBAhX

        public Axpgp02s()
        {
            InitializeComponent();
        }

        private unsafe void Axpgp02s_Load(object sender, EventArgs e)
        {
			string	szbuf;
			int		dwDllVer, dwDrvVer;	// DLL, Drivero[W
			bool	bResult;			// 
			short	wLogSocket;			// foCXi[
			short	wGpibAdrs;			// haAhX
			short	wGpibMode;			// ha[h
			int		dwFifoSize;			// haobt@TCY
			int		dwTimeout;			// ^CAEgl
			Axpgp02w.Resource  ri;		// \[X
			byte[] SendBuff = new byte[MAXBUFF];	// Mp̃obt@
			byte[] RecvBuff = new byte[MAXBUFF];	// Mp̃obt@
			int		dwDataCnt;			// Mf[^
			short	wSrqLine;			// rqpC
			byte	bStsByte;			// Xe[^XoCg
			short	i;					// [vpϐ

			// 
			Gp02w = new Axpgp02w();
			ri   = new Axpgp02w.Resource();
			ri.dwMemBase		= new int [Axpgp02w.MAX_MEM];
			ri.dwMemLength		= new int [Axpgp02w.MAX_MEM];
			ri.dwMemAttrib		= new int [Axpgp02w.MAX_MEM];
			ri.dwIOPortBase		= new int [Axpgp02w.MAX_IO];
			ri.dwIOPortLength	= new int [Axpgp02w.MAX_IO];
			ri.dwIRQRegisters	= new int [Axpgp02w.MAX_IRQ];
			ri.dwIRQAttrib		= new int [Axpgp02w.MAX_IRQ];
			ri.dwDMALst			= new int [Axpgp02w.MAX_DMA];
			ri.dwDMAAttrib		= new int [Axpgp02w.MAX_DMA];
			ri.dwReserved1		= new int [Axpgp02w.MAX_RSV];

			// 
			ri.dwNumMemWindows = 0;
			for (i=0; i<Axpgp02w.MAX_MEM; i++) 
			{
				ri.dwMemBase[i]   = 0;
				ri.dwMemLength[i] = 0;
				ri.dwMemAttrib[i] = 0;
			}
			ri.dwNumIOPorts = 0;
			for (i=0; i<Axpgp02w.MAX_IO; i++) 
			{
				ri.dwIOPortBase[i]   = 0;
				ri.dwIOPortLength[i] = 0;
			}
			ri.dwNumIRQs = 0;
			for (i=0; i<Axpgp02w.MAX_IRQ; i++) 
			{
				ri.dwIRQRegisters[i] = 0;
				ri.dwIRQAttrib[i]    = 0;
			}
			ri.dwNumDMAs = 0;
			for (i=0; i<Axpgp02w.MAX_DMA; i++) 
			{
				ri.dwDMALst[i]    = 0;
				ri.dwDMAAttrib[i] = 0;
			}
			for (i=0; i<Axpgp02w.MAX_RSV; i++) 
				ri.dwReserved1[i] = 0;

			//---------------------------------------------------------------
			// DLL,DRṼo[Wԍ擾
			//---------------------------------------------------------------
			if ( Gp02w.GetVersion(&dwDllVer, &dwDrvVer) == false ) 
			{
				ErrorMessage(Axpgp02w.SOCKET_AUTO);
				return;
			}
			szbuf = String.Concat("o[Wԍ擾\n",
				String.Format("DLL Version: {0:x8}h\n", dwDllVer), 
				String.Format("Drv Version: {0:x8}h",   dwDrvVer));
			ResultMessage(szbuf);

			//---------------------------------------------------------------
			// foCX̎gp錾
			//---------------------------------------------------------------
			wLogSocket = Axpgp02w.SOCKET_AUTO;		// gp̃foCXT܂B
			bResult = Gp02w.Create(&wLogSocket);	// ꍇA̎̃foCXi[܂B
			if ( bResult == false ) 
			{
				ErrorMessage(Axpgp02w.SOCKET_AUTO);
				return;
			}
			szbuf = String.Concat("foCX̎gp錾\n\n",
				String.Format("LogSlot: {0}", wLogSocket));
			ResultMessage(szbuf);
			
			//---------------------------------------------------------------
			// \[X擾
			//---------------------------------------------------------------
			if ( Gp02w.GetResource(wLogSocket, ref ri) == false ) 
			{
				ErrorMessage(wLogSocket);
				return;
			}
			szbuf = String.Concat("\[X擾\n",
				String.Format("NumPorts   : {0:x}h\n",
				ri.dwIOPortLength[0]),
				String.Format("IO Address : {0:x4}h - {1:x4}h\n",
				ri.dwIOPortBase[0], 
				ri.dwIOPortBase[0] + ri.dwIOPortLength[0] - 1), 
				String.Format("IRQ        : {0}", ri.dwIRQRegisters[0]));
			ResultMessage(szbuf);
			
			//---------------------------------------------------------------
			// aPCI-G01̏
			//---------------------------------------------------------------
			wGpibAdrs  = MYADRS;				// ̂haAhX
			wGpibMode  = Axpgp02w.MODE_SYSCON;	// Rg[ɂȂ
			dwFifoSize = MAXBUFF;				// FIFOobt@TCYw
			if ( Gp02w.Init(wLogSocket,wGpibAdrs,wGpibMode,dwFifoSize) == false ) 
			{
				ErrorMessage(wLogSocket);
				return;
			}
			szbuf = String.Concat("AXP-GP02̏\n\n", 
				String.Format("My IB-Address: {0}\n", wGpibAdrs), 
				String.Format("IB-Mode: {0}\n", wGpibMode),
				String.Format("FifoSize: {0}", dwFifoSize));
			ResultMessage(szbuf);
			
			//---------------------------------------------------------------
			// GP-IB ̃^CAEgݒ
			//---------------------------------------------------------------
			dwTimeout = 3000;	// ^CAEgl=Rb
			if ( Gp02w.SetTime(wLogSocket,dwTimeout) == false ) 
			{
				ErrorMessage(wLogSocket);
				return;
			}
			szbuf = String.Concat("GP-IB̃^CAEgݒ\n\n", 
				String.Format("Timeout: {0}msec", dwTimeout));
			ResultMessage(szbuf);
			
			//---------------------------------------------------------------
			// f~^Ƃdnhݒ
			//---------------------------------------------------------------
			if ( Gp02w.SetEos(wLogSocket,Axpgp02w.DELIM_CRLF,Axpgp02w.EOI_ON) == false) 
			{
				ErrorMessage(wLogSocket);
				return;
			}
			szbuf = String.Concat("f~^EOIݒ\n\n", 
				"f~^: CR+LF\n", 
				"EOI: On");
			ResultMessage(szbuf);
			
			//---------------------------------------------------------------
			// heb̑MiRg[pj
			//---------------------------------------------------------------
			if ( Gp02w.Ifc(wLogSocket) == false ) 
			{
				ErrorMessage(wLogSocket);
				return;
			}
			ResultMessage("heb̑M");
			
			//---------------------------------------------------------------
			// w@ւ̃f[^MiRg[pj
			//---------------------------------------------------------------
			wGpibAdrs = PRTADRS;		// XîhaAhX
			szbuf = "0123456789";		// Mf[^
			dwDataCnt = szbuf.Length;	// Mf[^
			SendBuff = System.Text.Encoding.GetEncoding(932).GetBytes(szbuf);
			fixed (byte* pSendBuff = SendBuff)
			if ( Gp02w.SendDataC(wLogSocket,wGpibAdrs,pSendBuff,dwDataCnt) == false ) 
			{
				ErrorMessage(wLogSocket);
				return;
			}
			ResultMessage("w@ւ̃f[^M");
			
			//---------------------------------------------------------------
			// w@킩̃f[^MiRg[pj
			//---------------------------------------------------------------
			wGpibAdrs = PRTADRS;			// g[ĴhaAhX
			dwDataCnt = 50;					// Mf[^
			fixed (byte* pRecvBuff = RecvBuff)
			if ( Gp02w.RecvDataC(wLogSocket,wGpibAdrs,pRecvBuff,&dwDataCnt) == false ) 
			{
				ErrorMessage(wLogSocket);
				return;
			}
			RecvBuff[dwDataCnt] = 0;
			szbuf = String.Concat("w@킩̃f[^M\n\n", 
				String.Format("DataCnt: {0}\n", dwDataCnt), 
				"Data   : ",
				System.Text.Encoding.GetEncoding(932).GetString(RecvBuff));
			ResultMessage(szbuf);
			
			//---------------------------------------------------------------
			// rqpC̏ԔiRg[pj
			//---------------------------------------------------------------
			if ( Gp02w.GetSrqLine(wLogSocket,&wSrqLine) == false ) 
			{
				ErrorMessage(wLogSocket);
				return;
			}
			szbuf = String.Concat("rqpC̏Ԕ\n\n", 
				String.Format("SRQ line: {0}", wSrqLine));
			ResultMessage(szbuf);
			
			//---------------------------------------------------------------
			// VA|[siRg[pj
			//---------------------------------------------------------------
			if ( wSrqLine == 1 ) 
			{
				wGpibAdrs = PRTADRS;				// VA|[haAhX
				if ( Gp02w.Spoll(wLogSocket,wGpibAdrs,&bStsByte) == false ) 
				{
					ErrorMessage(wLogSocket);
					return;
				}
				szbuf = String.Concat("VA|[s\n\n", 
					String.Format("STS Byte: {0:x2}h", bStsByte));
				ResultMessage(szbuf);
			}
			
			//---------------------------------------------------------------
			// foCX̎gpI
			//---------------------------------------------------------------
			if ( Gp02w.Close(wLogSocket) == false ) 
			{
				ErrorMessage(wLogSocket);
				return;
			}
			szbuf = String.Concat("foCX̎gpI\n\n", 
				String.Format("LogSlot: {0}", wLogSocket));
			ResultMessage(szbuf);
			this.Close();
        }

		//============================================================================
		// ʂ\
		//============================================================================
		private void ResultMessage(string buf)
		{
			MessageBox.Show(buf, this.Text, MessageBoxButtons.OK, MessageBoxIcon.Information);
		}

		//============================================================================
		// װүނ\
		//============================================================================
		private void ErrorMessage(short wLogSocket)
		{
			int dwRes = Gp02w.GetLastError(wLogSocket);
			string buf;

			switch (dwRes) 
			{
				case Axpgp02w.ERR_WRAPDLL:
				case Axpgp02w.ERR_SYSTEM:
					dwRes = System.Runtime.InteropServices.Marshal.GetLastWin32Error();
					buf = String.Concat("System error\n\n", 
						String.Format("Error code: {0:X8}h", dwRes));
					break;

				default:
					buf = String.Concat("AXP-GP02 error\n\n",
						String.Format("Error code: 0x{0:X8}h", dwRes));
					break;
			}
			MessageBox.Show(buf, this.Text, MessageBoxButtons.OK, MessageBoxIcon.Stop);
		}

    }
}