//============================================================================
//	Axpgp02w.h
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//============================================================================

#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;
using namespace System::Threading;
using namespace System::Runtime::InteropServices;

static int mErrWradll;	// bp[֐G[

public class Axpgp02w
{
public:
	// ő\Pbg
	static const int	MAX_SOCKETS				= 16;

	// _\Pbgw
	static const short	SOCKET_AUTO				= -1;

	//-------------------------------------------------------------------
	// G[R[h̒`
	//-------------------------------------------------------------------
	static const int	SUCCESS					= 0;		// ُȂiIj
	static const int	ERR_SYSTEM				= 1;		// Windows  GetLastError() R[Ă
															// ɃhCo[hĂȂ\܂
	static const int	ERR_NO_DEVICE			= 2;		// gp\ȃfoCX܂
	static const int	ERR_IN_USE				= 3;		// w̃foCX͎gpł
	static const int	ERR_INVALID_SOCKET		= 4;		// Ș_\Pbgł
	static const int	ERR_RESOURCE			= 5;		// \[XG[
	static const int	ERR_INVALID_ARGUMENT	= 6;		// p[^s
	static const int	ERR_NOTINIT				= 7;		// Ă܂B
	static const int	ERR_MODE				= 8;		// GPIB ̃[hG[łB
	static const int	ERR_TIMEOUT				= 9;		// ^CAEg܂B
	static const int	ERR_NOLSN				= 10;		// XiiP[uڑj
	static const int	ERR_BUSY				= 11;		// s
	static const int	ERR_ETC					= 12;		// ̑̃G[
	static const int	ERR_WRAPDLL				= -1;

	//-------------------------------------------------------------------
	// GPIB p[^`
	//-------------------------------------------------------------------

	// GPIBXe[^X擾
	static const int	STS_IFC					= 0x0001;	// IFC
	static const int	STS_DCAS				= 0x0002;	// DeviceClear
	static const int	STS_UNC					= 0x0004;	// Ppoll,TCT etc
	static const int	STS_ERR					= 0x0008;	// Error
	static const int	STS_GET					= 0x0010;	// GET
	static const int	STS_SPAS				= 0x0020;	// Spoll
	static const int	STS_END					= 0x0040;	// END
	static const int	STS_REM					= 0x0100;	// Remote
	static const int	STS_LLO					= 0x0200;	// LLO
	static const int	STS_TLK					= 0x0400;	// Talker
	static const int	STS_LSN					= 0x0800;	// Listener
	static const int	STS_ATN					= 0x1000;	// ATN
	static const int	STS_SRQ					= 0x2000;	// SRQ
	static const int	STS_REN					= 0x4000;	// REN

	// GPIB֘Ap[^w͈
	static const short	ADDR_MIN				= 0;		// ŏGPIBڽ
	static const short	ADDR_MAX				= 30;		// ő    "
	static const int	TIMEOUT_DEFAULT			= 2000L;	// ѱ̫
	static const int	TIMEOUT_MAX				= 60000L;	// ѱčől

	// }`CbZ[W(GPIBR}h)w
	static const Byte	LA_0					= 0x20;		// Listener Addr
	static const Byte	TA_0					= 0x40;		// Talker Addr
	static const Byte	UNL						= 0x3f;		// UNListen
	static const Byte	UNT						= 0x5F;		// UNTalk
	static const Byte	GTL						= 0x01;		// Go To Local
	static const Byte	SDC						= 0x04;		// Select Device Clear
	static const Byte	LLO						= 0x11;		// Local Lock Out
	static const Byte	DCL						= 0x14;		// Device Clear
	static const Byte	SPE						= 0x18;		// Serial Poll Enable
	static const Byte	SPD						= 0x19;		// Serial Poll Disable
	static const Byte	PPC						= 0x05;		// Parallel Poll Config
	static const Byte	PPE						= 0x60;		// Parallel Poll Enable
	static const Byte	PPZ						= 0x70;		// Parallel Poll Disable
	static const Byte	PPU						= 0x15;		// Parallel Poll Unconfig
	static const Byte	TCT						= 0x09;		// Take Control (XXX)

	// GPIB샂[hw
	static const short	MODE_SYSCON				= 1;		// Ѻ۰Ӱ
	static const short	MODE_TLKLSN				= 0;		// İؽӰ
	static const short	MODE_SLAVE				= 0;		// ڰӰ
	static const short	MODE_CON				= 2;		// ۰Ӱ(gps)
	static const short	MODE_MASTER				= 2;		// ϽӰ(gps)

	// f~^[hw
	static const short	DELIM_CRLF				= 1;		// CR + LF(̫)
	static const short	DELIM_CR				= 2;		// CR
	static const short	DELIM_LF				= 3;		// LF
	static const short	DELIM_NO				= 0;		// NOTHING

	// dnh[hw
	static const short	EOI_ON					= 1;		// t(̫)
	static const short	EOI_OFF					= 0;		// Ȃ

	//-------------------------------------------------------------------
	// \[X
	//-------------------------------------------------------------------
	static const int	MAX_MEM					= 9;		// MAX_MEM_REGISTERS
	static const int	MAX_IO					= 20;		// MAX_IO_PORTS
	static const int	MAX_IRQ					= 7;		// MAX_IRQS
	static const int	MAX_DMA					= 7;		// MAX_DMA_CHANNELS
	static const int	MAX_RSV					= 3;		// MAX_Reserved1

	struct Resource {
		int dwNumMemWindows;
		int dwMemBase[Axpgp02w::MAX_MEM];
		int dwMemLength[Axpgp02w::MAX_MEM];
		int dwMemAttrib[Axpgp02w::MAX_MEM];
		int dwNumIOPorts;
		int dwIOPortBase[Axpgp02w::MAX_IO];
		int dwIOPortLength[Axpgp02w::MAX_IO];
		int dwNumIRQs;
		int dwIRQRegisters[Axpgp02w::MAX_IRQ];
		int dwIRQAttrib[Axpgp02w::MAX_IRQ];
		int dwNumDMAs;
		int dwDMALst[Axpgp02w::MAX_DMA];
		int dwDMAAttrib[Axpgp02w::MAX_DMA];
		int dwReserved1[Axpgp02w::MAX_RSV];
	};

	//-------------------------------------------------------------------
	// API
	//-------------------------------------------------------------------
	[DllImport("axpgp02.dll")]
	static int  Gp02GetLastError( short wLogSocket );
	[DllImport("axpgp02.dll")]
	static int  Gp02GetStatus( short wLogSocket );
	[DllImport("axpgp02.dll")]
	static bool Gp02GetVersion( int* pdwDllVersion, int* pdwDriverVersion );
	[DllImport("axpgp02.dll")]
	static bool Gp02Create( short* pwLogSocket );
	[DllImport("axpgp02.dll")]
	static bool Gp02Close( short wLogSocket );
	[DllImport("axpgp02.dll")]
	static bool Gp02GetResource( short wLogSocket, [In][Out] Resource* res );
	[DllImport("axpgp02.dll")]
	static bool Gp02Init( short wLogSocket, short wGpibAddr, short wGpibMode, int dwFifoSize );
	[DllImport("axpgp02.dll")]
	static bool Gp02SetTime( short wLogSocket, int dwTimeoutCnt );
	[DllImport("axpgp02.dll")]
	static bool Gp02SetEos( short wLogSocket, short wDlmMode, short wEoiMode );
	[DllImport("axpgp02.dll")]
	static bool Gp02SendCmd( short wLogSocket, Byte* paSendBuf, int dwSendBytes );
	[DllImport("axpgp02.dll")]
	static bool Gp02Ifc( short wLogSocket );
	[DllImport("axpgp02.dll")]
	static bool Gp02Ren( short wLogSocket, short wRenLine );
	[DllImport("axpgp02.dll")]
	static bool Gp02Dcl( short wLogSocket );
	[DllImport("axpgp02.dll")]
	static bool Gp02Sdc( short wLogSocket, short wLsnAdrs );
	[DllImport("axpgp02.dll")]
	static bool Gp02SendDataCN( short wLogSocket, short* pwLsnAdrsList, short wLsnAdrsCnt, Byte* pbSendBuff, int dwDataCnt );
	[DllImport("axpgp02.dll")]
	static bool Gp02SendDataC( short wLogSocket, short wLsnAdrs, Byte* pbSendBuff, int dwDataCnt );
	[DllImport("axpgp02.dll")]
	static bool Gp02SendDataS( short wLogSocket, Byte* pbSendBuff, int dwDataCnt );
	[DllImport("axpgp02.dll")]
	static bool Gp02RecvDataC( short wLogSocket, short wTlkAdrs, Byte* pbRecvBuff, int* pdwDataCnt );
	[DllImport("axpgp02.dll")]
	static bool Gp02RecvDataS( short wLogSocket, byte* pbRecvBuff, int* pdwDataCnt );
	[DllImport("axpgp02.dll")]
	static bool Gp02TransDataN( short wLogSocket, short wTlkAdrs, short* pwLsnAdrsList, short wLsnAdrsCnt );
	[DllImport("axpgp02.dll")]
	static bool Gp02TransData( short wLogSocket, short wTlkAdrs, short wLsnAdrs );
	[DllImport("axpgp02.dll")]
	static bool Gp02SetSrqLine( short wLogSocket, Byte bStsByte );
	[DllImport("axpgp02.dll")]
	static bool Gp02GetSrqLine( short wLogSocket, short* pwSrqLine );
	[DllImport("axpgp02.dll")]
	static bool Gp02Spoll( short wLogSocket, short wPollAdrs, Byte* pbStsByte );
	[DllImport("axpgp02.dll")]
	static bool Gp02Ppoll( short wLogSocket, Byte* pbDioLine );
	[DllImport("axpgp02.dll")]
	static bool Gp02PpollConfig( short wLogSocket, short wLsnAdrs, Byte bDioLine, Byte bSbit );
	[DllImport("axpgp02.dll")]
	static bool Gp02PpollUnConfig ( short wLogSocket, short wLsnAdrs );
	[DllImport("axpgp02.dll")]
	static bool Gp02PpollUnConfigAll( short wLogSocket );
	[DllImport("axpgp02.dll")]
	static bool Gp02PpollRespModeSet( short wLogSocket, short wPMode );

	//===================================================================
	//   		G[R[h擾
	//   		wLogSocket		foCX
	// ߂l		G[R[h
	//===================================================================
	static int GetLastError( short wLogSocket )
	{
		try {
			if (mErrWradll == ERR_WRAPDLL) {	// bp[֐G[Ȃ
				mErrWradll = SUCCESS;			// NA
				return ERR_WRAPDLL;
			} else {
				return Gp02GetLastError(wLogSocket);
			}
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "AXP-GP02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = SUCCESS;	// bp[֐G[
			return ERR_WRAPDLL;
		}
	}
	//===================================================================
	//   		GPIBXe[^X̎擾
	//   		wLogSocket		foCX
	// ߂l		true	
	//				false	s
	//===================================================================
	static int GetStatus( short wLogSocket )
	{
		mErrWradll = SUCCESS;
		try {
			return Gp02GetStatus(wLogSocket);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "AXP-GP02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		o[Wԍ擾
	//   		pdwDllVersion	DLL o[Wi[̈ւ̃|C^
	//				pdwDrvVersion	DRV o[Wi[̈ւ̃|C^
	// ߂l		true	
	//				false	s
	//===================================================================
	static bool GetVersion( int* pdwDllVersion, int* pdwDrvVersion )
	{
		mErrWradll = SUCCESS;
		try {
			return Gp02GetVersion(pdwDllVersion, pdwDrvVersion);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "AXP-GP02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		foCX̎gp錾
	//   		pwLogSocket		foCXi[̈ւ̃|C^
	// ߂l		true	
	//				false	s
	//===================================================================
	static bool Create( short* pwLogSocket )
	{
		mErrWradll = SUCCESS;
		try {
			return Gp02Create(pwLogSocket);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "AXP-GP02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		foCX̉
	//   		wLogSocket		foCX
	// ߂l		true	
	//				false	s
	//===================================================================
	static bool Close( short wLogSocket )
	{
		mErrWradll = SUCCESS;
		try {
			return Gp02Close(wLogSocket);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "AXP-GP02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		\[X擾
	//   		wLogSocket		foCX
	//				res				\[Xi[̈ւ̃|C^
	// ߂l		true	
	//				false	s
	//===================================================================
	static bool GetResource( short wLogSocket, [In][Out] Resource* res )
	{
		mErrWradll = SUCCESS;
		try {
			return	Gp02GetResource(wLogSocket, res);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "AXP-GP02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		
	//   		wLogSocket		foCX̘_Ĕԍ
	//				wGpibAddr   	g GP-IB AhX
	//				wGpibMode		g GP-IB 샂[h
	//				dwFifoSize		Mobt@̑傫
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool Init( short wLogSocket, short wGpibAddr, short wGpibMode, int dwFifoSize )
	{
		mErrWradll = SUCCESS;
		try {
			return Gp02Init(wLogSocket, wGpibAddr, wGpibMode, dwFifoSize);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "AXP-GP02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		GPIBѱĐݒ
	//   		wLogSocket		foCX̘_Ĕԍ
	//				dwTimeoutCnt  	^CAEglBPʂ̓~b0`60000܂ŁB
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool SetTime( short wLogSocket, int dwTimeoutCnt )
	{
		mErrWradll = SUCCESS;
		try {
			return Gp02SetTime(wLogSocket, dwTimeoutCnt);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "AXP-GP02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		EOIݒ
	//   		wLogSocket		foCX̘_Ĕԍ
	//				wDlmMode    	f~^w
	//				wEoiMode    	dnh̎gp܂͕sgpw
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool SetEos( short wLogSocket, short wDlmMode, short wEoiMode )
	{
		mErrWradll = SUCCESS;
		try {
			return Gp02SetEos(wLogSocket, wDlmMode, wEoiMode);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "AXP-GP02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		GPIBޑM(۰חp)
	//   		wLogSocket		foCX̘_Ĕԍ
	//				paSendBuf   	MR}hobt@̃AhX
	//				dwSendBytes		MׂR}h̃oCg
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool SendCmd( short wLogSocket, Byte* paSendBuf, int dwSendBytes )
	{
		mErrWradll = SUCCESS;
		try {
			return Gp02SendCmd(wLogSocket, paSendBuf, dwSendBytes);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "AXP-GP02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		IFCM(۰חp)
	//   		wLogSocket		foCX̘_Ĕԍ
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool Ifc( short wLogSocket )
	{
		mErrWradll = SUCCESS;
		try {
			return Gp02Ifc(wLogSocket);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "AXP-GP02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		RENײ݂̐ݒ(۰חp)
	//   		wLogSocket		foCX̘_Ĕԍ
	//				wRenLine		1(^)/0(U)
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool Ren( short wLogSocket, short wRenLine )
	{
		mErrWradll = SUCCESS;
		try {
			return Gp02Ren(wLogSocket, wRenLine);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "AXP-GP02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		DCLM(۰חp)
	//   		wLogSocket		foCX̘_Ĕԍ
	// ߂l		 	true
	//				s 	false
	//===================================================================
	static bool Dcl( short wLogSocket )
	{
		mErrWradll = SUCCESS;
		try {
			return Gp02Dcl(wLogSocket);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "AXP-GP02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		w@ւSDCM(۰חp)
	//   		wLogSocket		foCX̘_Ĕԍ
	//				wLsnAdrs		XiAhX
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool Sdc( short wLogSocket, short wLsnAdrs )
	{
		mErrWradll = SUCCESS;
		try {
			return Gp02Sdc(wLogSocket, wLsnAdrs);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "AXP-GP02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		̎w@ւްM(۰חp)
	//   		wLogSocket		foCX̘_Ĕԍ
	//				pwLsnAdrsList 	XiAhXXg̃AhX
	//				wLsnAdrsCnt		XiAhX̐
	//				pbSendBuff		Mf[^obt@̃AhX
	//				dwDataCnt		Mf[^
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool SendDataCN( short wLogSocket, short* pwLsnAdrsList, short wLsnAdrsCnt, Byte* pbSendBuff, int dwDataCnt )
	{
		mErrWradll = SUCCESS;
		try {
			return Gp02SendDataCN(wLogSocket, pwLsnAdrsList, wLsnAdrsCnt, pbSendBuff, dwDataCnt);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "AXP-GP02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		w@ւްM(۰חp)
	//   		wLogSocket		foCX̘_Ĕԍ
	//				wLsnAdrs		XiAhX
	//				pbSendBuff		Mf[^obt@̃AhX
	//				dwDataCnt   	Mf[^
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool SendDataC( short wLogSocket, short wLsnAdrs, Byte* pbSendBuff, int dwDataCnt )
	{
		mErrWradll = SUCCESS;
		try {
			return Gp02SendDataC(wLogSocket, wLsnAdrs, pbSendBuff, dwDataCnt);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "AXP-GP02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		ްM(ڰޗp)
	//   		wLogSocket		foCX̘_Ĕԍ
	//				pbSendBuff		Mf[^obt@̃AhX
	//				dwDataCnt		Mf[^
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool SendDataS( short wLogSocket, Byte* pbSendBuff, int dwDataCnt )
	{
		mErrWradll = SUCCESS;
		try {
			return Gp02SendDataS(wLogSocket, pbSendBuff, dwDataCnt);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "AXP-GP02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		w@킩ްM(۰חp)
	//   		wLogSocket		foCX̘_Ĕԍ
	//				wTlkAdrs		g[JAhX
	//				pbRecvBuff		Mf[^obt@̃AhX
	//				pdwDataCnt		Mf[^w肷ϐ̃AhX
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool RecvDataC( short wLogSocket, short wTlkAdrs, Byte* pbRecvBuff, int* pdwDataCnt )
	{
		mErrWradll = SUCCESS;
		try {
			return Gp02RecvDataC(wLogSocket, wTlkAdrs, pbRecvBuff, pdwDataCnt);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "AXP-GP02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		ްM(ڰޗp)
	//   		wLogSocket		foCX̘_Ĕԍ
	//				pbRecvBuff 		Mf[^obt@̃AhX
	//				pdwDataCnt  	Mf[^w肷ϐ̃AhX
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool RecvDataS( short wLogSocket, Byte* pbRecvBuff, int* pdwDataCnt )
	{
		mErrWradll = SUCCESS;
		try {
			return Gp02RecvDataS(wLogSocket, pbRecvBuff, pdwDataCnt);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "AXP-GP02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		@ް](۰חp)
	//   		wLogSocket		foCX̘_Ĕԍ
	//				wTlkAdrs      	g[JAhX
	//				pwLsnAdrsList	XiAhXXg̃AhX
	//				wLsnAdrsCnt		XiAhX̐
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool TransDataN( short wLogSocket, short wTlkAdrs, short* pwLsnAdrsList, short wLsnAdrsCnt )
	{
		mErrWradll = SUCCESS;
		try {
			return Gp02TransDataN(wLogSocket, wTlkAdrs, pwLsnAdrsList, wLsnAdrsCnt);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "AXP-GP02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		@ް](۰חp)
	//   		wLogSocket		foCX̘_Ĕԍ
	//				wTlkAdrs		g[JAhX
	//				wLsnAdrs		XiAhX
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool TransData( short wLogSocket, short wTlkAdrs, short wLsnAdrs )
	{
		mErrWradll = SUCCESS;
		try {
			return Gp02TransData(wLogSocket, wTlkAdrs, wLsnAdrs);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "AXP-GP02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		SRQײ݂ƽð޲Đݒ(ڰޗp)
	//   		wLogSocket		foCX̘_Ĕԍ
	//				bStsByte		Xe[^XoCgl
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool SetSrqLine( short wLogSocket, Byte bStsByte )
	{
		mErrWradll = SUCCESS;
		try {
			return Gp02SetSrqLine(wLogSocket, bStsByte);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "AXP-GP02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		SRQײ݂̏Ԕ(۰חp)
	//   		wLogSocket		foCX̘_Ĕԍ
	//				pwSrqLine		rqpCԂi[ϐ̃AhX
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool GetSrqLine( short wLogSocket, short* pwSrqLine )
	{
		mErrWradll = SUCCESS;
		try {
			return Gp02GetSrqLine(wLogSocket, pwSrqLine);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "AXP-GP02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		رَ߰s(۰חp)
	//   		wLogSocket		foCX̘_Ĕԍ
	//				wPollAdrs		|[ÕAhX
	//				pbStsByte		Xe[^XoCgi[ϐ̃AhX
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool Spoll( short wLogSocket, short wPollAdrs, Byte* pbStsByte )
	{
		mErrWradll = SUCCESS;
		try {
			return Gp02Spoll(wLogSocket, wPollAdrs, pbStsByte);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "AXP-GP02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		َ߰s(۰חp)
	//   		wLogSocket		foCX̘_Ĕԍ
	//				pbDioLine   	chnCi[ϐ̃AhX
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool Ppoll( short wLogSocket, Byte* pbDioLine )
	{
		mErrWradll = SUCCESS;
		try {
			return Gp02Ppoll(wLogSocket, pbDioLine);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "AXP-GP02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		ٍ߰\(۰חp)
	//   		wLogSocket		foCX̘_Ĕԍ
	//				wLsnAdrs		\@AhX
	//				bDioLine    	@tDIOCԍiO`ṼrbgԍŎwj
	//				bSbit			ZXrbg̎wiO܂͂Pj
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool PpollConfig( short wLogSocket, short wLsnAdrs, Byte bDioLine, Byte bSbit )
	{
		mErrWradll = SUCCESS;
		try {
			return Gp02PpollConfig(wLogSocket, wLsnAdrs, bDioLine, bSbit);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "AXP-GP02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		w@ٍ߰\(۰חp)
	//   		wLogSocket		foCX̘_Ĕԍ
	//				wLsnAdrs		\@AhX
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool PpollUnConfig( short wLogSocket, short wLsnAdrs )
	{
		mErrWradll = SUCCESS;
		try {
			return Gp02PpollUnConfig(wLogSocket, wLsnAdrs);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "AXP-GP02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		S@ٍ߰\(۰חp)
	//   		wLogSocket		foCX̘_Ĕԍ
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool PpollUnConfigAll( short wLogSocket )
	{
		mErrWradll = SUCCESS;
		try {
			return Gp02PpollUnConfigAll(wLogSocket);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "AXP-GP02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		߰ىݒ(ڰޗp)
	//   		wLogSocket		foCX̘_Ĕԍ
	//				wPMode			p|[ւ̉@
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool PpollRespModeSet( short wLogSocket, short wPMode )
	{
		mErrWradll = SUCCESS;
		try {
			return Gp02PpollRespModeSet(wLogSocket, wPMode);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "AXP-GP02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

};
