//===================================================================
// AXP-GP02 user application interface
//-------------------------------------------------------------------
// Copyright (c) ADTEK SYSTEM SCIENCE Co.,Ltd.
//===================================================================
#define GP02_SOCKET_AUTO	((WORD) ~0U)
#define GP02_MAX_SOCKETS	16
//-------------------------------------------------------------------
// \[X\
//-------------------------------------------------------------------
#define GP02_MAX_MEM		9
#define GP02_MAX_IO			20
#define GP02_MAX_IRQ		7
#define GP02_MAX_DMA		7

typedef struct _GP02_RESOURCE {
    DWORD   dwNumMemWindows;						// Not used
    DWORD   dwMemBase       [GP02_MAX_MEM];			// Not used
    DWORD   dwMemLength     [GP02_MAX_MEM];			// Not used
    DWORD   dwMemAttrib     [GP02_MAX_MEM];			// Not used
    DWORD   dwNumIOPorts;							// Num IO ports
    DWORD   dwIOPortBase    [GP02_MAX_IO];			// I/O port base
    DWORD   dwIOPortLength  [GP02_MAX_IO];			// I/O port length
    DWORD   dwNumIRQs;								// NumIRQs
    DWORD   dwIRQRegisters  [GP02_MAX_IRQ];			// IRQ Registers
    DWORD   dwIRQAttrib     [GP02_MAX_IRQ];			// IRQ Attrib
	DWORD	dwNumDMAs;								// Not used
    DWORD   dwDMALst        [GP02_MAX_DMA];			// Not used
    DWORD   dwDMAAttrib     [GP02_MAX_DMA];			// Not used
    DWORD   dwReserved1     [3];					// Not used
} GP02_RESOURCE, *PGP02RESOURCE;
//-------------------------------------------------------------------
// G[R[hi1/3/8/12DLLŃZbgj
//-------------------------------------------------------------------
#define GP02_SUCCESS				0	// ُȂiIj
#define GP02_ERR_SYSTEM				1	// Windows  GetLastError() R[Ă
										// ɃhCo[hĂȂ\܂
#define GP02_ERR_NO_DEVICE			2	// gp\ȃfoCX܂
#define GP02_ERR_IN_USE				3	// w̃foCX͎gpł
#define GP02_ERR_INVALID_SOCKET		4	// Ș_\Pbgł
#define GP02_ERR_RESOURCE			5	// \[XG[

#define GP02_ERR_INVALID_ARGUMENT	6	// p[^s
#define	GP02_ERR_NOTINIT			7 	// Ă܂B
#define	GP02_ERR_MODE				8 	// GPIB ̃[hG[łB
#define	GP02_ERR_TIMEOUT			9 	// ^CAEg܂B
#define	GP02_ERR_NOLSN				10	// XiiP[uڑj
#define	GP02_ERR_BUSY				11	// s
#define	GP02_ERR_ETC				12	// ̑̃G[
