//============================================================================
//	axpGP02w.c
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//============================================================================
#include <windows.h>
#include <tchar.h>
#include "axpgp02w.h"
//---------- X^eBbN֐ & X^eBbNϐ(萔)	----------------------
static BOOL _Gp02wGetDllExportFunc( void );
static HMODULE hDLL = NULL;

// DLL GNX|[g֐AhX̊i[pϐ
static	FARPROC	pGp02GetLastError;
static	FARPROC	pGp02GetStatus;
static	FARPROC	pGp02GetVersion;
static	FARPROC	pGp02Create;
static	FARPROC	pGp02Close;
static	FARPROC	pGp02GetResource;
static	FARPROC	pGp02Init;
static	FARPROC	pGp02SetTime;
static	FARPROC	pGp02SetEos;
static	FARPROC	pGp02SendCmd;
static	FARPROC	pGp02Ifc;
static	FARPROC	pGp02Ren;
static	FARPROC	pGp02Dcl;
static	FARPROC	pGp02Sdc;
static	FARPROC	pGp02SendDataCN;
static	FARPROC	pGp02SendDataC;
static	FARPROC	pGp02SendDataS;
static	FARPROC	pGp02RecvDataC;
static	FARPROC	pGp02RecvDataS;
static	FARPROC	pGp02TransDataN;
static	FARPROC	pGp02TransData;
static	FARPROC	pGp02SetSrqLine;
static	FARPROC	pGp02GetSrqLine;
static	FARPROC	pGp02Spoll;
static	FARPROC	pGp02Ppoll;
static	FARPROC	pGp02PpollConfig;
static	FARPROC	pGp02PpollUnConfig;
static	FARPROC	pGp02PpollUnConfigAll;
static	FARPROC	pGp02PpollRespModeSet;

BOOL Gp02wDllOpen ( void )
//============================================================================
// 		DLL۰(۰ގʹװƂ)
// 		
// ߂l	 	TRUE
//			s 	FALSE
//============================================================================
{
	if (hDLL == NULL){
		hDLL = (HMODULE)LoadLibrary(GP02_DLL_NAME);
		if (hDLL != NULL){
			if (_Gp02wGetDllExportFunc() == TRUE){
				return TRUE;
			}else{
				// DLL֐擾ɎŝDLLN[Y
				Gp02wDllClose();
			}
		}
	}
	return FALSE;
}

BOOL Gp02wDllClose ( void )
//============================================================================
// 		DLL۰(۰ގʹװƂ)
// 		
// ߂l 	 	TRUE
//			s 	FALSE
//============================================================================
{
	if (hDLL != NULL){
		if (TRUE == FreeLibrary(hDLL)){
			hDLL = NULL;
			return TRUE;
		}
	}
	return FALSE;
}

DWORD Gp02wGetLastError ( WORD wLogSocket )
//============================================================================
// 		װނ̎擾
// 		wLogSocket		޲̘_Ĕԍ
// ߂l 	װ
//============================================================================
{
	if (hDLL == NULL){
		return GP02_ERR_WRAPDLL;
	}else{
		return (*pGp02GetLastError)(wLogSocket);
	}
}

DWORD Gp02wGetStatus ( WORD wLogSocket )
//============================================================================
// 		GPIBð̎擾
// 		wLogSocket		޲̘_Ĕԍ
// ߂l 	 	TRUE
//			s 	FALSE
//============================================================================
{
	return (*pGp02GetStatus)(wLogSocket);
}

BOOL Gp02wGetVersion ( PDWORD pdwDllVersion, PDWORD pdwDriverVersion )
//============================================================================
// 		DLL,޲ײްްޮݔԍ擾
// 		pdwDllVersion		DLLްޮݔԍi[̈ւ߲
//			pdwDriverVersion	޲ײްްޮݔԍi[̈ւ߲
// ߂l 	 	TRUE
//			s 	FALSE
//============================================================================
{
	return (*pGp02GetVersion)(pdwDllVersion, pdwDriverVersion);
}

BOOL Gp02wCreate ( PWORD pwLogSocket )
//============================================================================
// 		޲̎gp錾
// 		pwLogSocket		gp޲̘_Ĕԍi[߲
// ߂l 	 	TRUE
//			s 	FALSE
//============================================================================
{
	return (*pGp02Create)(pwLogSocket);
}

BOOL Gp02wClose ( WORD wLogSocket )
//============================================================================
// 		޲J
// 		wLogSocket		޲̘_Ĕԍ
// ߂l 	 	TRUE
//			s 	FALSE
//============================================================================
{
	return (*pGp02Close)(wLogSocket);
}

BOOL Gp02wGetResource ( WORD wLogSocket, PGP02RESOURCE pResInfo )
//============================================================================
// 		w޲ؿ擾
// 		wLogSocket		޲̘_Ĕԍ
//			pResInfo		ؿi[\߲̂
// ߂l 	 	TRUE
//			s 	FALSE
//============================================================================
{
	return	(*pGp02GetResource)(wLogSocket, pResInfo);
}

BOOL Gp02wInit ( WORD wLogSocket, WORD wGpibAddr, WORD wGpibMode, DWORD dwFifoSize )
//============================================================================
// 		
// 		wLogSocket		޲̘_Ĕԍ
//			wGpibAddr   	g GP-IB AhX
//			wGpibMode		g GP-IB 샂[h
//			dwFifoSize		Mobt@̑傫
// ߂l 	 	TRUE
//			s 	FALSE
//============================================================================
{
	return (*pGp02Init)(wLogSocket, wGpibAddr, wGpibMode, dwFifoSize);
}

BOOL Gp02wSetTime ( WORD wLogSocket, DWORD dwTimeoutCnt )
//============================================================================
// 		GPIBѱĐݒ
// 		wLogSocket		޲̘_Ĕԍ
//			dwTimeoutCnt  	^CAEglBPʂ̓~b0`60000܂ŁB
// ߂l 	 	TRUE
//			s 	FALSE
//============================================================================
{
	return (*pGp02SetTime)(wLogSocket, dwTimeoutCnt);
}

BOOL Gp02wSetEos ( WORD wLogSocket, WORD wDlmMode, WORD wEoiMode )
//============================================================================
// 		EOIݒ
// 		wLogSocket		޲̘_Ĕԍ
//			wDlmMode    	f~^w
//			wEoiMode    	dnh̎gp܂͕sgpw
// ߂l 	 	TRUE
//			s 	FALSE
//============================================================================
{
	return (*pGp02SetEos)(wLogSocket, wDlmMode, wEoiMode);
}

BOOL Gp02wSendCmd ( WORD wLogSocket, PBYTE paSendBuf, DWORD dwSendBytes )
//============================================================================
// 		GPIBޑM(۰חp)
// 		wLogSocket		޲̘_Ĕԍ
//			paSendBuf   	MR}hobt@̃AhX
//			dwSendBytes		MׂR}h̃oCg
// ߂l 	 	TRUE
//			s 	FALSE
//============================================================================
{
	return (*pGp02SendCmd)(wLogSocket, paSendBuf, dwSendBytes);
}

BOOL Gp02wIfc ( WORD wLogSocket )
//============================================================================
// 		IFCM(۰חp)
// 		wLogSocket		޲̘_Ĕԍ
// ߂l 	 	TRUE
//			s 	FALSE
//============================================================================
{
	return (*pGp02Ifc)(wLogSocket);
}

BOOL Gp02wRen ( WORD wLogSocket, WORD wRenLine )
//============================================================================
// 		RENײ݂̐ݒ(۰חp)
// 		wLogSocket		޲̘_Ĕԍ
//			wRenLine		1(^)/0(U)
// ߂l 	 	TRUE
//			s 	FALSE
//============================================================================
{
	return (*pGp02Ren)(wLogSocket, wRenLine);
}

BOOL Gp02wDcl ( WORD wLogSocket )
//============================================================================
// 		DCLM(۰חp)
// 		wLogSocket		޲̘_Ĕԍ
// ߂l	 	TRUE
//			s 	FALSE
//============================================================================
{
	return (*pGp02Dcl)(wLogSocket);
}

BOOL Gp02wSdc ( WORD wLogSocket, WORD wLsnAdrs )
//============================================================================
// 		w@ւSDCM(۰חp)
// 		wLogSocket		޲̘_Ĕԍ
//			wLsnAdrs		XiAhX
// ߂l 	 	TRUE
//			s 	FALSE
//============================================================================
{
	return (*pGp02Sdc)(wLogSocket, wLsnAdrs);
}

BOOL Gp02wSendDataCN ( WORD wLogSocket, PWORD pwLsnAdrsList, WORD wLsnAdrsCnt, PBYTE pbSendBuff, DWORD dwDataCnt )
//============================================================================
// 		̎w@ւްM(۰חp)
// 		wLogSocket		޲̘_Ĕԍ
//			pwLsnAdrsList 	XiAhXXg̃AhX
//			wLsnAdrsCnt		XiAhX̐
//			pbSendBuff		Mf[^obt@̃AhX
//			dwDataCnt		Mf[^
// ߂l 	 	TRUE
//			s 	FALSE
//============================================================================
{
	return (*pGp02SendDataCN)(wLogSocket, pwLsnAdrsList, wLsnAdrsCnt, pbSendBuff, dwDataCnt);
}

BOOL Gp02wSendDataC ( WORD wLogSocket, WORD wLsnAdrs, PBYTE pbSendBuff, DWORD dwDataCnt )
//============================================================================
// 		w@ւްM(۰חp)
// 		wLogSocket		޲̘_Ĕԍ
//			wLsnAdrs		XiAhX
//			pbSendBuff		Mf[^obt@̃AhX
//			dwDataCnt   	Mf[^
// ߂l 	 	TRUE
//			s 	FALSE
//============================================================================
{
	return (*pGp02SendDataC)(wLogSocket, wLsnAdrs, pbSendBuff, dwDataCnt);
}

BOOL Gp02wSendDataS ( WORD wLogSocket, PBYTE pbSendBuff, DWORD dwDataCnt )
//============================================================================
// 		ްM(ڰޗp)
// 		wLogSocket		޲̘_Ĕԍ
//			pbSendBuff		Mf[^obt@̃AhX
//			dwDataCnt		Mf[^
// ߂l 	 	TRUE
//			s 	FALSE
//============================================================================
{
	return (*pGp02SendDataS)(wLogSocket, pbSendBuff, dwDataCnt);
}

BOOL Gp02wRecvDataC ( WORD wLogSocket, WORD wTlkAdrs, PBYTE pbRecvBuff, PDWORD pdwDataCnt )
//============================================================================
// 		w@킩ްM(۰חp)
// 		wLogSocket		޲̘_Ĕԍ
//			wTlkAdrs		g[JAhX
//			pbRecvBuff		Mf[^obt@̃AhX
//			pdwDataCnt		Mf[^w肷ϐ̃AhX
// ߂l 	 	TRUE
//			s 	FALSE
//============================================================================
{
	return (*pGp02RecvDataC)(wLogSocket, wTlkAdrs, pbRecvBuff, pdwDataCnt);
}

BOOL Gp02wRecvDataS ( WORD wLogSocket, PBYTE pbRecvBuff, PDWORD pdwDataCnt )
//============================================================================
// 		ްM(ڰޗp)
// 		wLogSocket		޲̘_Ĕԍ
//			pbRecvBuff 		Mf[^obt@̃AhX
//			pdwDataCnt  	Mf[^w肷ϐ̃AhX
// ߂l 	 	TRUE
//			s 	FALSE
//============================================================================
{
	return (*pGp02RecvDataS)(wLogSocket, pbRecvBuff, pdwDataCnt);
}

BOOL Gp02wTransDataN ( WORD wLogSocket, WORD wTlkAdrs, PWORD pwLsnAdrsList, WORD wLsnAdrsCnt )
//============================================================================
// 		@ް](۰חp)
// 		wLogSocket		޲̘_Ĕԍ
//			wTlkAdrs      	g[JAhX
//			pwLsnAdrsList	XiAhXXg̃AhX
//			wLsnAdrsCnt		XiAhX̐
// ߂l 	 	TRUE
//			s 	FALSE
//============================================================================
{
	return (*pGp02TransDataN)(wLogSocket, wTlkAdrs, pwLsnAdrsList, wLsnAdrsCnt);
}

BOOL Gp02wTransData ( WORD wLogSocket, WORD wTlkAdrs, WORD wLsnAdrs )
//============================================================================
// 		@ް](۰חp)
// 		wLogSocket		޲̘_Ĕԍ
//			wTlkAdrs		g[JAhX
//			wLsnAdrs		XiAhX
// ߂l 	 	TRUE
//			s 	FALSE
//============================================================================
{
	return (*pGp02TransData)(wLogSocket, wTlkAdrs, wLsnAdrs);
}

BOOL Gp02wSetSrqLine ( WORD wLogSocket, BYTE bStsByte )
//============================================================================
// 		SRQײ݂ƽð޲Đݒ(ڰޗp)
// 		wLogSocket		޲̘_Ĕԍ
//			bStsByte		Xe[^XoCgl
// ߂l 	 	TRUE
//			s 	FALSE
//============================================================================
{
	return (*pGp02SetSrqLine)(wLogSocket, bStsByte);
}

BOOL Gp02wGetSrqLine ( WORD wLogSocket, PWORD pwSrqLine )
//============================================================================
// 		SRQײ݂̏Ԕ(۰חp)
// 		wLogSocket		޲̘_Ĕԍ
//			pwSrqLine		rqpCԂi[ϐ̃AhX
// ߂l 	 	TRUE
//			s 	FALSE
//============================================================================
{
	return (*pGp02GetSrqLine)(wLogSocket, pwSrqLine);
}

BOOL Gp02wSpoll ( WORD wLogSocket, WORD wPollAdrs, PBYTE pbStsByte )
//============================================================================
// 		رَ߰s(۰חp)
// 		wLogSocket		޲̘_Ĕԍ
//			wPollAdrs		|[ÕAhX
//			pbStsByte		Xe[^XoCgi[ϐ̃AhX
// ߂l 	 	TRUE
//			s 	FALSE
//============================================================================
{
	return (*pGp02Spoll)(wLogSocket, wPollAdrs, pbStsByte);
}

BOOL Gp02wPpoll ( WORD wLogSocket, PBYTE pbDioLine )
//============================================================================
// 		َ߰s(۰חp)
// 		wLogSocket		޲̘_Ĕԍ
//			pbDioLine   	chnCi[ϐ̃AhX
// ߂l 	 	TRUE
//			s 	FALSE
//============================================================================
{
	return (*pGp02Ppoll)(wLogSocket, pbDioLine);
}

BOOL Gp02wPpollConfig ( WORD wLogSocket, WORD wLsnAdrs, BYTE bDioLine, BYTE bSbit )
//============================================================================
// 		ٍ߰\(۰חp)
// 		wLogSocket		޲̘_Ĕԍ
//			wLsnAdrs		\@AhX
//			bDioLine    	@tDIOCԍiO`ṼrbgԍŎwj
//			bSbit			ZXrbg̎wiO܂͂Pj
// ߂l 	 	TRUE
//			s 	FALSE
//============================================================================
{
	return (*pGp02PpollConfig)(wLogSocket, wLsnAdrs, bDioLine, bSbit);
}

BOOL Gp02wPpollUnConfig ( WORD wLogSocket, WORD wLsnAdrs )
//============================================================================
// 		w@ٍ߰\(۰חp)
// 		wLogSocket		޲̘_Ĕԍ
//			wLsnAdrs		\@AhX
// ߂l 	 	TRUE
//			s 	FALSE
//============================================================================
{
	return (*pGp02PpollUnConfig)(wLogSocket, wLsnAdrs);
}

BOOL Gp02wPpollUnConfigAll ( WORD wLogSocket )
//============================================================================
// 		S@ٍ߰\(۰חp)
// 		wLogSocket		޲̘_Ĕԍ
// ߂l 	 	TRUE
//			s 	FALSE
//============================================================================
{
	return (*pGp02PpollUnConfigAll)(wLogSocket);
}

BOOL Gp02wPpollRespModeSet ( WORD wLogSocket, WORD wPMode )
//============================================================================
// 		߰ىݒ(ڰޗp)
// 		wLogSocket		޲̘_Ĕԍ
//			wPMode			p|[ւ̉@
// ߂l 	 	TRUE
//			s 	FALSE
//============================================================================
{
	return (*pGp02PpollRespModeSet)(wLogSocket, wPMode);
}

static BOOL _Gp02wGetDllExportFunc ( void )
//----------------------------------------------------------------------------
// 	  	DLL߰Ċ֐ڽ̎擾
// 	  	
// ߂l 	 	TRUE
//		  	s 	FALSE
//----------------------------------------------------------------------------
{
	pGp02GetLastError = GetProcAddress(hDLL, _T("Gp02GetLastError"));
	if (pGp02GetLastError == NULL)	return FALSE;
	pGp02GetStatus = GetProcAddress(hDLL, _T("Gp02GetStatus"));
	if (pGp02GetStatus == NULL)	return FALSE;
	pGp02GetVersion = GetProcAddress(hDLL, _T("Gp02GetVersion"));
	if (pGp02GetVersion == NULL)	return FALSE;
	pGp02Create = GetProcAddress(hDLL, _T("Gp02Create"));
	if (pGp02Create == NULL)	return FALSE;
	pGp02Close = GetProcAddress(hDLL, _T("Gp02Close"));
	if (pGp02Close == NULL)	return FALSE;
	pGp02GetResource = GetProcAddress(hDLL, _T("Gp02GetResource"));
	if (pGp02GetResource == NULL)	return FALSE;
	pGp02Init = GetProcAddress(hDLL, _T("Gp02Init"));
	if (pGp02Init == NULL)	return FALSE;
	pGp02SetTime = GetProcAddress(hDLL, _T("Gp02SetTime"));
	if (pGp02SetTime == NULL)	return FALSE;
	pGp02SetEos = GetProcAddress(hDLL, _T("Gp02SetEos"));
	if (pGp02SetEos == NULL)	return FALSE;
	pGp02SendCmd = GetProcAddress(hDLL, _T("Gp02SendCmd"));
	if (pGp02SendCmd == NULL)	return FALSE;
	pGp02Ifc = GetProcAddress(hDLL, _T("Gp02Ifc"));
	if (pGp02Ifc == NULL)	return FALSE;
	pGp02Ren = GetProcAddress(hDLL, _T("Gp02Ren"));
	if (pGp02Ren == NULL)	return FALSE;
	pGp02Dcl = GetProcAddress(hDLL, _T("Gp02Dcl"));
	if (pGp02Dcl == NULL)	return FALSE;
	pGp02Sdc = GetProcAddress(hDLL, _T("Gp02Sdc"));
	if (pGp02Sdc == NULL)	return FALSE;
	pGp02SendDataCN = GetProcAddress(hDLL, _T("Gp02SendDataCN"));
	if (pGp02SendDataCN == NULL)	return FALSE;
	pGp02SendDataC = GetProcAddress(hDLL, _T("Gp02SendDataC"));
	if (pGp02SendDataC == NULL)	return FALSE;
	pGp02SendDataS = GetProcAddress(hDLL, _T("Gp02SendDataS"));
	if (pGp02SendDataS == NULL)	return FALSE;
	pGp02RecvDataC = GetProcAddress(hDLL, _T("Gp02RecvDataC"));
	if (pGp02RecvDataC == NULL)	return FALSE;
	pGp02RecvDataS = GetProcAddress(hDLL, _T("Gp02RecvDataS"));
	if (pGp02RecvDataS == NULL)	return FALSE;
	pGp02TransDataN = GetProcAddress(hDLL, _T("Gp02TransDataN"));
	if (pGp02TransDataN == NULL)	return FALSE;
	pGp02TransData = GetProcAddress(hDLL, _T("Gp02TransData"));
	if (pGp02TransData == NULL)	return FALSE;
	pGp02SetSrqLine = GetProcAddress(hDLL, _T("Gp02SetSrqLine"));
	if (pGp02SetSrqLine == NULL)	return FALSE;
	pGp02GetSrqLine = GetProcAddress(hDLL, _T("Gp02GetSrqLine"));
	if (pGp02GetSrqLine == NULL)	return FALSE;
	pGp02Spoll = GetProcAddress(hDLL, _T("Gp02Spoll"));
	if (pGp02Spoll == NULL)	return FALSE;
	pGp02Ppoll = GetProcAddress(hDLL, _T("Gp02Ppoll"));
	if (pGp02Ppoll == NULL)	return FALSE;
	pGp02PpollConfig = GetProcAddress(hDLL, _T("Gp02PpollConfig"));
	if (pGp02PpollConfig == NULL)	return FALSE;
	pGp02PpollUnConfig = GetProcAddress(hDLL, _T("Gp02PpollUnConfig"));
	if (pGp02PpollUnConfig == NULL)	return FALSE;
	pGp02PpollUnConfigAll = GetProcAddress(hDLL, _T("Gp02PpollUnConfigAll"));
	if (pGp02PpollUnConfigAll == NULL)	return FALSE;
	pGp02PpollRespModeSet = GetProcAddress(hDLL, _T("Gp02PpollRespModeSet"));
	if (pGp02PpollRespModeSet == NULL)	return FALSE;
	// SĂ DLL ߰Ċ֐ڽ擾nj
	return TRUE;
}

